<?php


/**
 * @version    CVS: 1.0.0
 * @package    com_miniorangesociallogin
 * @author     miniOrange Security Software Pvt. Ltd. <info@xecurify.com>
 * @copyright  Copyright 2015 miniOrange. All Rights Reserved.
 * @license    GNU/GPLv3
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );


jimport( 'joomla.application.component.model' );

/**
 * miniOrange SAML System plugin
 */

class plgSystemSocialloginredirect extends JPlugin {

    function onAfterInitialise() {

        if ( isset( $_REQUEST['mojsp_feedback'] ) ) {


            jimport( 'miniorangesamlplugin.utility.Utilities' );

            $radio = $_REQUEST['deactivate_plugin'];
            $data  = $_REQUEST['query_feedback'];
            $post = JFactory::getApplication()->input->post->getArray();
            $feedback_email = isset($post['feedback_email']) ? $post['feedback_email'] : '';
            

            $db    = JFactory::getDbo();
            $query = $db->getQuery( true );
            // Fields to update.
            $fields = array(
                $db->quoteName( 'uninstall_feedback' ) . ' = ' . $db->quote( 1 )
            );

            // Conditions for which records should be updated.
            $conditions = array(
                $db->quoteName( 'id' ) . ' = 1'
            );

            $query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
            $db->setQuery( $query );
            $result = $db->execute();


            $current_user = JFactory::getUser();

            $db    = JFactory::getDbo();
            $query = $db->getQuery( true );
            $query->select( array( '*' ) );
            $query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
            $query->where( $db->quoteName( 'id' ) . " = 1" );
            $db->setQuery( $query );
            $customerResult = $db->loadAssoc();


            $admin_email = (isset($customerResult['email']) && !empty($customerResult['email'])) ? $customerResult['email'] : $feedback_email;
            $admin_phone = $customerResult['admin_phone'];



            $data1 = $radio . ' : ' . $data;

            require_once JPATH_BASE . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_miniorangesociallogin' . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'mo-sociallogin-customer-setup.php';

            Mo_Sociallogin_Local_Customer::submit_feedback_form( $admin_email, $admin_phone, $data1 );

            require_once JPATH_SITE . DIRECTORY_SEPARATOR . 'libraries' . DIRECTORY_SEPARATOR . 'src' . DIRECTORY_SEPARATOR . 'Installer' . DIRECTORY_SEPARATOR . 'Installer.php';

            foreach ( $_REQUEST['result'] as $fbkey ) {

                $db    = JFactory::getDbo();
                $query = $db->getQuery( true );
                $query->select( 'type' );
                $query->from( '#__extensions' );
                $query->where( $db->quoteName( 'extension_id' ) . " = " . $db->quote( $fbkey ) );
                $db->setQuery( $query );
                $result = $db->loadColumn();

                $identifier = $fbkey;
                $type       = 0;
                foreach ( $result as $results ) {

                    $type = $results;
                }

                if ( $type ) {

                    $cid = 0;

                    $installer = new JInstaller();
                    $installer->uninstall( $type, $identifier, $cid );
                }
            }

        }
        if(isset($_REQUEST['option']) and ($_REQUEST['option']=='mo_profile_complete_submit'))
        {
            $username = $_REQUEST['username'];
            $email = $_REQUEST['email'];
            $userid = $_REQUEST['userid'];
            $appname = $_REQUEST['appName'];

            if($this->getUserByMail($email))
            {

                $html = $this->mo_profile_completion($username, $email, $userid,$appname,"Email address already registered");
                echo $html;
                exit();
            }
            if($this->getUserbyUsername($username))
            {
                $html = $this->mo_profile_completion($username, $email, $userid,$appname,"Username already in use");
                echo $html;
                exit();
            }
            //Get miniOrange Customer details to use in encryption of OTP
            $otp = rand(99999, 1000000);
            $tId = $this->generateTId($otp);
            $mail_success = $this->mo_send_mail($otp, $email);
            if($mail_success)
            {
                $sent_time = time();
                echo $this->showEmailVerificationForm($email, $username, $tId, $sent_time,$userid,$appname); exit();
            }
            else
            {
                echo "Error sending mail";exit();
            }

        }
        if(isset($_REQUEST['option']) and $_REQUEST['option']=='go_back_used')
        {
            $email = $_REQUEST['email'];
            $username = $_REQUEST['username'];
            $userid = $_REQUEST['userid'];
            $appname = $_REQUEST['appName'];
            $html = $this->mo_profile_completion($username, $email,$userid,$appname);
            echo $html;
            exit();
        }

        if(isset($_REQUEST['option']) and $_REQUEST['option']=='otp_validation')
        {
            if(isset($_REQUEST['resend_otp']))
            {
                $username = $_REQUEST['username'];
                $email = $_REQUEST['email'];
                $appname = $_REQUEST['appName'];
                $userid = $_REQUEST['userid'];
                $otp = rand(99999, 1000000);
                $tId = $this->generateTId($otp);
                $mail_success = $this->mo_send_mail($otp, $email);
                $sent_time = time();
                if($mail_success)
                {
                    $sent_time = time();
                    echo $this->showEmailVerificationForm($email, $username, $tId, $sent_time,$userid, $appname,"A new OTP has been sent to given email address"); exit();
                }
                else
                {
                    echo "Error sending mail";exit();
                }
            }
            //storing user details

            $username = $_REQUEST['username'];
            $email = $_REQUEST['email'];
            $appname = $_REQUEST['appName'];
            $userid = $_REQUEST['userid'];

            //get Customer key for decryption
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('*');
            $query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
            $query->where($db->quoteName('id')." = 1");

            $db->setQuery($query);
            $result = $db->loadAssoc();
            $customerKey    = $result['customer_key'];
            //start checks

            $pass = $this->checkTimeStamp($_REQUEST['sent_time'], time());
            if(!$pass)
            {
                $username = $_REQUEST['username'];
                $email = $_REQUEST['email'];
                $email = $_REQUEST['email'];
                $otp = rand(99999, 1000000);
                $tId = $this->generateTId($otp);
                $mail_success = $this->mo_send_mail($otp, $email);
                $sent_time=time();
                if($mail_success)
                {
                    $sent_time = time();
                    echo $this->showEmailVerificationForm($email, $username, $tId, $sent_time, $userid, $appname, "Your OTP has expired. A new OTP has been sent to you.");
                    exit();
                }
                else
                {
                    echo "Error sending mail";exit();
                }
            }
            else
                $pass = $this->checkTransactionId($_REQUEST['tId'], $customerKey, $_REQUEST['otp_field'], $pass);
            if($pass)
            {

                $this->createUser($username,$email,$userid,$appname);

            }
            else
            {
                $html = $this->showEmailVerificationForm($email, $username, $_REQUEST['tId'], $_REQUEST['sent_time'], $userid, $appname, "You entered an incorrect OTP. Please enter a valid and correct OTP.");
                echo $html;
                exit();
            }
        }
        if(isset($_REQUEST['option']) and $_REQUEST['option']=='username_form_submitted')
        {
            if($_REQUEST['email']=='')
            {echo $this->mo_profile_completion($_REQUEST['username'],$_REQUEST['email'],$_REQUEST['userid'],$_REQUEST['appName']);exit();}
            if(!$this->getUserbyUsername($_REQUEST['username']))
            {
                $this->createUser($_REQUEST['username'], $_REQUEST['email'], $_REQUEST['userid'], $_REQUEST['appName']);
            }
            else
            {
                echo $this->showUsernameForm($_REQUEST['username'], $_REQUEST['email'], $_REQUEST['userid'], $_REQUEST['appName']);
                exit();
            }
        }
        if(isset($_REQUEST['create_account_btn']))
        {
            $session = array('username'=>$_REQUEST['username'], 'email'=>$_REQUEST['email'], 'userid'=>$_REQUEST['userid'], 'appname'=>$_REQUEST['appName'],'account_link'=>FALSE);
            $ses_obj = JFactory::getSession();
            $ses_obj->set('NEWSESSIONID',$session);
            $username = $_REQUEST['username'];
            $email = $_REQUEST['email'];
            $userid = $_REQUEST['userid'];
            $appname = $_REQUEST['appName'];

            if($username == '')
            {
                $parts = explode('@', $email);
                $username = $parts[0];
            }
            //check for existing users. can be optimized by handling existing user exception in createUser() function
            if($this->getUserByMail($email) || $email==null)
            {
                $html = $this->mo_profile_completion($username, $email, $userid, $appname);
                echo $html;
                exit();
            }
            if($this->getUserbyUsername($username))
            {
                $html = $this->showUsernameForm($username, $email, $userid, $appname);
                echo $html;
                exit();
            }

            $this->createUser($username, $email, $userid, $appname);

        }
        if(isset($_REQUEST['link_account_btn']))
        {
            $session = array('username'=>$_REQUEST['username'], 'email'=>$_REQUEST['email'], 'userid'=>$_REQUEST['userid'], 'appname'=>$_REQUEST['appName'],'account_link'=>true);
            $ses_obj = JFactory::getSession();
            $ses_obj->set('session',$session);

            /*$html = '<link rel="stylesheet/less" type="text/css" href="/slogin/administrator/templates/hathor/less/template.less" />
            <script src="//cdnjs.cloudflare.com/ajax/libs/less.js/3.9.0/less.min.js" type="text/javascript"></script>';
            echo $html;
            $document   = JFactory::getDocument();
            $renderer   = $document->loadRenderer('module');
            $params = array('style'=>'xhtml');
            echo $renderer->render(JModuleHelper::getModule('mod_login','Login with existing account'), $params);exit();*/
            $redirectUrl = 'index.php?tag=link_return';
            $redirectUrl = urlencode(base64_encode($redirectUrl));
            $redirectUrl = "&return=$redirectUrl";
            $JoomlaLoginUrl = 'index.php?option=com_users&view=login';
            header("Location: $JoomlaLoginUrl$redirectUrl");

        }
        if( isset($_REQUEST['tag']) and $_REQUEST['tag']=='link_return') {
            $user = JFactory::getUser();
            $app = JFactory::getApplication('site');
            if ($user->id != 0) {
                $session = JFactory::getSession();
                $ses_array = $session->get('session');
                $appname = $ses_array['appname'];
                $userid = $ses_array['userid'];
                $username = $ses_array['username'];
                $email = $ses_array['email'];

                //check if it is an account linking redirect. make database entry in linked_users if it is.
                if ($ses_array['account_link']) {
                    $db = JFactory::getDbo();
                    $columns = array('appname', 'userid', 'email', 'identifier');
                    $values = array($db->quote($appname), $user->id, $db->quote($email), $db->quote($userid));
                    $query = $db->getQuery(true);
                    $query->insert($db->quoteName('#__miniorangesociallogin_linked_user'))
                        ->columns($db->quoteName($columns))
                        ->values(implode(',', $values));
                    $db->setQuery($query);
                    $db->execute();
                }

                $logger = JUser::getInstance($user->id);
                jimport('joomla.user.authentication');
                $jauth = new JAuthentication;
                $response = new JAuthenticationResponse;
                $session = JFactory::getSession();
                $app = JFactory::getApplication('site');
                $response->status = JAuthentication::STATUS_SUCCESS;
                $session->set('user', $logger);

                $app->checkSession();
                $app->redirect('index.php', "Welcome $user->username", 'message');
            }
        }
    }
    function showUsernameForm($username, $email, $userid, $appname)
    {
        $html =
            '<style>.form-input-validation.note {color: #00d9d0;}</style>
             <body style="background-color: lightgrey">
             <div style="position:fixed;background:#f1f1f1;"></div>
             <div id="add_field" style="position:fixed;top: 0;right: 0;bottom: 0;left: 0;z-index: 1;padding-top:70px;">
             <div style="width: 500px; height:325px;margin: 30px auto; background: white; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
             <form name="profile_completion_form" action="" method="post">
             <div style="text-align: center; padding-top: 16px;"><span style="font-size: 24px;font-family: Arial">New Username</span></div><br>
             <div style="padding: 12px;"></div>
             <div style="padding: 16px;background-color: rgba(1, 145, 191, 0.117647);color: black;margin-left: 16px;margin-right: 16px;">
             <span style="color: black;font-size: 14px; text-align: justify; line-height: 20px;cursor: pointer;font-family: Arial;transition: 0.3s;">Your username <b>"'.$username.'"</b> is already in use on this site. Please enter a new username of your choice.</span></div><br>
             <p style="padding-left: 18px">
             <label for="user_login" style="font-family: sans-serif">Username<br/>
             <input style="width: 464px;height: 40px;font-size: 20px;border-top-width: 1px;border-left-width: 1px;border-right-width: 1px;border-bottom-width: 1px;border-radius: 4px;text-indent: 8px;background: ghostwhite;" type="text" class="input" name="username" size="20" required></label>
             </p>
             <input style="margin-left: 407px;height: 41px;width: 73px;border-radius: 6px;border-top-width: 1px;border-bottom-width: 1px;border-right-width: 1px;border-left-width: 1px;background: powderblue;" type="submit" value="Submit">
             <input type="hidden" name="option" value="username_form_submitted">
             <input type="hidden" name="email" value="'.$email.'">
             <input type="hidden" name="userid" value="'.$userid.'">
             <input type="hidden" name="appName" value="'.$appname.'">
             </form>
             </div>
             </div>
             </body>';
        return $html;
    }
    function checkTimeStamp($sentOn,$validationTime)
    {
        $diff = round(abs($validationTime - $sentOn)/60, 2);
        if($diff > 1)
            return false;
        else
            return true;
    }
    function checkTransactionId($tId, $customerKey, $otp, $pass)
    {
        if(!$pass)
        {
            echo "transaction checker" ;exit();
            return false;
        }
        else
        {
            $transactionId = $customerKey.$otp;
            $transactionId = hash("sha512", $transactionId);
            if($tId==$transactionId)
                return true;
            else
                return false;
        }

    }

    function showEmailVerificationForm($email, $username, $tId, $sent_time, $userid, $appname, $message="Please enter the OTP sent to given mail account")
    {
        $html = '<body style="background-color: lightgrey">
             <div style="position:fixed;background:#f1f1f1;"></div>
             <div id="add_field" style="position:fixed;top: 0;right: 0;bottom: 0;left: 0;z-index: 1;padding-top:70px;">
             <div style="width: 500px; height:222px;margin: 30px auto; background: white; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
             <form name="otp_validation_form" action="" method="post">
             <div style="padding: 12px;"></div>
             <div style="padding: 16px;background-color: rgba(1, 145, 191, 0.117647);color: black;margin-left: 16px;margin-right: 16px;">
             <span style="color: black;font-size: 14px; text-align: justify; line-height: 20px;cursor: pointer;font-family: Arial;transition: 0.3s;">'.$message.'</span></div><br>
             <p style="padding-left: 18px">
             <input style="width: 464px;height: 40px;font-size: 20px;border-top-width: 1px;border-left-width: 1px;border-right-width: 1px;border-bottom-width: 1px;border-radius: 4px;text-indent: 8px;background: ghostwhite;" type="text" class="input" name="otp_field" size="20" pattern="[0-9]{5,7}"></label>
             </p>
             <input style="float: right;margin-right: 17px; height: 41px;width: 73px;border-radius: 6px;border-top-width: 1px;border-bottom-width: 1px;border-right-width: 1px;border-left-width: 1px;background: powderblue;" type="submit" value="Submit">
             <input style="float: right;margin-right: 12px; height: 41px;width: 89px;border-radius: 6px;border-top-width: 1px;border-bottom-width: 1px;border-right-width: 1px;border-left-width: 1px;background: powderblue" name="resend_otp" type="submit" value="Resend OTP">
             <input style="float: left;margin-left: 17px;height: 41px;width: 73px;border-radius: 6px;border-top-width: 1px;border-bottom-width: 1px;border-right-width: 1px;border-left-width: 1px;background: powderblue;" onClick=submitGoBack(); type="button" name="go_back_form_submit" value="Prev">
             <input type="hidden" name="option" value="otp_validation">
             <input type="hidden" name="tId" value="'.$tId.'">
             <input type="hidden" name="email" value="'.$email.'">
             <input type="hidden" name="sent_time" value="'.$sent_time.'">
             <input type="hidden" name="username" value="'.$username.'">
             <input type="hidden" name="userid" value="'.$userid.'">
             <input type="hidden" name="appName" value="'.$appname.'">
             </form>
             </div>
             </div>
             <form hidden name="go_back_form" id="goBackForm" action="" method="post">
             <input type="hidden" name="username" value="'.$username.'">
             <input type="hidden" name="email" value="'.$email.'">
             <input type="hidden" name="userid" value="'.$userid.'">
             <input type="hidden" name="appName" value="'.$appname.'">
             <input type="hidden" name="option" value="go_back_used">
             </form>
             <script type="text/javascript">
             function submitGoBack() {
               document.getElementById("goBackForm").submit();
             }
             </script>
             </body>';
        return $html;

    }

    function generateTId($otp)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
        $query->where($db->quoteName('id')." = 1");

        $db->setQuery($query);
        $result = $db->loadAssoc();

        $customerKey    = $result['customer_key'];
        $transactionId = $customerKey.$otp;
        $tId = hash("sha512", $transactionId);
        return $tId;
    }

    function mo_send_mail($otp, $email)
    {
        $mail_body = "Dear User, 
            Enter OTP ".$otp;
        $mailer_obj = JFactory::getMailer();
        $config = JFactory::getConfig();
        $sender = array($config->get('mailfrom'), $config->get('fromname'));
        $mailer_obj->setSender($sender);
        $mailer_obj->addRecipient($email);
        $mailer_obj->setSubject("OTP");
        $mailer_obj->setBody($mail_body);
        $mail_success = $mailer_obj->Send();
        return $mail_success;
    }
    function mo_profile_completion($username, $email, $userid, $appname ,$message=null)
    {

        $username = empty($username) ? $_GET['username'] : '' ;
        $email = empty($email) ? $_GET['email']: '' ;
        $userid = empty($userid) ? $_GET['userid'] : '';
        $appname = empty($appname) ? $_GET['appName'] : '' ;


        $uri = JRoute::_( 'index.php?option=mod_miniorangesociallogin&task=default.mo_openid_login_validate' );

        JLog::add('entered Profile Completion function',Jlog::DEBUG,'entry-log');
        $html = '<style>.form-input-validation.note {color: #00d9d0;}</style>
             <body style="background-color: lightgrey">
             <div style="position:fixed;background:#f1f1f1;"></div>
             <div id="add_field" style="position:fixed;top: 0;right: 0;bottom: 0;left: 0;z-index: 1;padding-top:70px;">
             <div style="width: 500px; height:472px;margin: 30px auto; background: white; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
             <div style="text-align:center">
             <span style="text-align: center; color: indianred;" align="center">'.$message.'</span>
             </div>
             <form name="profile_completion_form" action="" method="post">
             <div style="text-align: center; padding-top: 16px;"><span style="font-size: 24px;font-family: Arial">Profile Completion</span></div><br>
             <div style="padding: 12px;"></div>
             <div style="padding: 16px;background-color: rgba(1, 145, 191, 0.117647);color: black;margin-left: 16px;margin-right: 16px;">
             <span style="color: black;font-size: 14px; text-align: justify; line-height: 20px;cursor: pointer;font-family: Arial;transition: 0.3s;">If you are an existing user on this site, enter your registered email and username. If you are a new user, please edit/fill the details.</span></div><br>
             <p style="padding-left: 18px">
             <label for="user_login" style="font-family: sans-serif">Username<br/>
             <input style="width: 464px;height: 40px;font-size: 20px;border-top-width: 1px;border-left-width: 1px;border-right-width: 1px;border-bottom-width: 1px;border-radius: 4px;text-indent: 8px;background: ghostwhite;" type="text" class="input" name="username" size="20" required value='.$username.'></label>
             </p>
             <p style="padding-left: 18px;">
             <label for="user_pass" style="font-family: sans-serif">Email<br/>
             <input style="width: 464px;height: 40px;font-size: 20px;border-top-width: 1px;border-left-width: 1px;border-right-width: 1px;border-bottom-width: 1px;border-radius: 4px;text-indent: 8px;background: ghostwhite;" type="email"  class="input" pattern="[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]+$" name="email" required value="'.$email.'"></label><br><br>
             <span align="center" class="form-input-validation note" style="font-family: monospace;color: crimson;">We will send an OTP to this email address. Please enter a valid email address.</span>
             </p>
             <input type="hidden" name="userid" value="'.$userid.'">
             <input type="hidden" name="appName" value="'.$appname.'">
             <input style="margin-left: 407px;height: 41px;width: 73px;border-radius: 6px;border-top-width: 1px;border-bottom-width: 1px;border-right-width: 1px;border-left-width: 1px;background: powderblue;" type="submit" value="Submit">
             <input type="hidden" name="option" value="mo_profile_complete_submit">
             </form>
             </div>
             </div>
             </body>';
        return $html;
    }

    function getUserByMail($email)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true)
            ->select($db->quoteName('id'))
            ->from($db->quoteName('#__users'))
            ->where($db->quoteName('email') . ' = ' . $db->quote($email));
        $db->setQuery($query);

        if ($id = $db->loadResult())
        {

            $user = JTable::getInstance('User', 'JTable', array());
            $user->load($id);
            return $user;
        }
        else
        {
            return null;
        }
    }
    function getUserbyUsername($username)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true)
            ->select($db->quoteName('id'))
            ->from($db->quoteName('#__users'))
            ->where($db->quoteName('username').' = '.$db->quote($username));
        $db->setQuery($query);

        if($id = $db->loadResult())
        {
            $user = JTable::getInstance('User','Jtable',array());
            $user->load($id);
            return $user;
        }
        else
        {
            return null;
        }
    }

    function createUser($username, $email, $userid, $appname)
    {
        JLog::add('Entered createUser function', JLog::ALERT, 'my-error-log');

        if(!(isset($username))){

            isset($parts) ? $parts = explode('@', $email) : '';
            $username = $parts[0];
        }

        $data['name'] = $username;
        $data['username'] = $username;
        $data['email'] = $data['email1'] = $data['email2'] = $email;
        $data['password'] = $data['password1'] = $data['password2'] = JUserHelper::genRandomPassword();
        $data['activation'] = '0';
        $data['block'] = '0';


        jimport( 'joomla.application.component.model' );

        if ( ! defined( 'JPATH_COMPONENT' ) ) {
            define( 'JPATH_COMPONENT', JPATH_BASE . '/components/' );}
        $app      = JFactory::getApplication( 'site' );

        $user = new JUser();

        if (!$user->bind($data))
        {
            throw new Exception("Could not bind data. Error: " . $user->getError());
        }

        if (!$user->save())
        {
            throw new Exception("Could not save user. Error: " . $user->getError());
        }

        $login_url = 'index.php';
        $email = $data['email'];
        $username = $data['username'];
        $matcher='email';
        //$result = get_user_from_joomla( $matcher, $username, $email );
        //Check if email exist in database
        $db = JFactory::getDBO();

        switch ( $matcher ) {
            case 'username':
                $query = $db->getQuery( true )
                    ->select( 'id' )
                    ->from( '#__users' )
                    ->where( 'username=' . $db->quote( $username ) );

                break;
            case 'email':
                $query = $db->getQuery( true )
                    ->select( 'id' )
                    ->from( '#__users' )
                    ->where( 'email=' . $db->quote( $email ) );
                break;
            default:
                $query = $db->getQuery( true )
                    ->select( 'id' )
                    ->from( '#__users' )
                    ->where( 'email=' . $db->quote( $email ) );


                break;
        }

        $db->setQuery( $query );
        $result = $db->loadObject();
        if ( $result )
        {
            //prep query for inserting into linked_user table
            $columns = array('appname','userid','email','identifier');
            $values = array($db->quote($appname),$result->id,$db->quote($email),$db->quote($userid));
            $query = $db->getQuery(true);

            $query->insert($db->quoteName('#__miniorangesociallogin_linked_user'))
                ->columns($db->quoteName($columns))
                ->values(implode(',',$values));
            $db->setQuery($query);

            $db->execute();
            //insert query executed. Log the user in now
            $user    = JUser::getInstance($result->id);

            jimport('joomla.user.authentication');
            $jauth = new JAuthentication();
            $response = new JAuthenticationResponse();
            $session = JFactory::getSession();
            $app = JFactory::getApplication('site');
            $response->status = JAuthentication::STATUS_SUCCESS;
            $session->set('user', $user);
            $app->checkSession();
            $app->redirect('index.php', "Welcome $user->username", 'message');


        }
    }

    function showAccountLinkForm($username, $email, $userid, $appname)
    {
        $html = '<style>.form-input-validation.note {color: #00d9d0;}</style>
             <body id="account_link_body" style="background-color: lightgrey">
             <div style="position:fixed;background:#f1f1f1;"></div>
             <div id="add_field" style="position:fixed;top: 0;right: 0;bottom: 0;left: 0;z-index: 1;padding-top:70px;">
             <div style="width: 500px; height:272px;margin: 30px auto; background: white; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
             <form name="profile_completion_form" action="" method="post">
             <div style="text-align: center; padding-top: 16px;"><span style="font-size: 24px;font-family: Arial">Account Linking</span></div><br>
             <div style="padding: 12px;"></div>
             <div style="padding: 16px;background-color: rgba(1, 145, 191, 0.117647);color: black;margin-left: 16px;margin-right: 16px;">
             <span style="color: black;font-size: 14px; text-align: justify; line-height: 20px;cursor: pointer;font-family: Arial;transition: 0.3s;">If you are an existing user on this site, you can choose <b>link account</b> and link your credentials to your existing account or proceed with <b>creating a new account</b>.</span></div><br>
             <input style="float: right;margin-right: 15px; height: 41px;width: 113px;border-radius: 6px;border-top-width: 1px;border-bottom-width: 1px;border-right-width: 1px;border-left-width: 1px;background: powderblue;" type="submit" name="create_account_btn" value="Create Account">
             <input style="float: left;margin-left: 15px; height: 41px;width: 113px;border-radius: 6px;border-top-width: 1px;border-bottom-width: 1px;border-right-width: 1px;border-left-width: 1px;background: powderblue;" type="submit" name="link_account_btn" value="Link Account">
             <input type="hidden" name="userid" value="'.$userid.'">
             <input type="hidden" name="username" value="'.$username.'">
             <input type="hidden" name="email" value="'.$email.'">
             <input type="hidden" name="appName" value="'.$appname.'">
             </form>
             </div>
             </div>
             <script type="text/javascript">document.getElementById("module").style.display = "none";</script>
             </body>';

        return $html;
    }

    function onExtensionBeforeUninstall( $id ) {

        $db    = JFactory::getDbo();
        $query = $db->getQuery( true );
        $query->select( 'extension_id' );
        $query->from( '#__extensions' );

        $query->where( $db->quoteName( 'name' ) . " = " . $db->quote( 'Miniorange Social Login' ) );
        $db->setQuery( $query );
        $result = $db->loadColumn();
        $tables = JFactory::getDbo()->getTableList();
        $tab    = 0;
        foreach ( $tables as $table ) {
            if ( strpos( $table, "miniorangesociallogin_customer_details" ) ) {
                $tab = $table;
            }
        }


        if ( $tab ) {

            $db    = JFactory::getDbo();
            $query = $db->getQuery( true );
            $query->select( 'uninstall_feedback' );
            $query->from( '#__miniorangesociallogin_customer_details' );
            $query->where( $db->quoteName( 'id' ) . " = " . $db->quote( 1 ) );
            $db->setQuery( $query );
            $fid = $db->loadColumn();


            $tpostData = $_REQUEST;


            foreach ( $fid as $value ) {

                if ( $value == 0 ) {
                    foreach ( $result as $results ) {

                        if ( $results == $id ) {
                            ?>

                            <div class="form-style-6 ">
                                <!-- <span class="mojsp_close">close;</span> -->
                                <h1> FeedBack Form for Social Login</h1>
                                <h3>What Happened? </h3>

                                <form name="f" method="post" action="" id="mojsp_feedback">
                                    <input type="hidden" name="mojsp_feedback" value="mojsp_feedback"/>
                                    <div>
                                        <p style="margin-left:2%">
                                            <?php
                                            $deactivate_reasons = array(
                                                "Facing issues During Registration",
                                                "Not receving OTP During Registration",
                                                "Does not have the features I'm looking for",
                                                "Not able to Configure",
                                                "Bugs in the plugin",
                                                "Other Reasons"
                                            );


                                            foreach ( $deactivate_reasons

                                            as $deactivate_reasons ) { ?>

                                        <div class=" radio " style="padding:1px;margin-left:2%">
                                            <label style="font-weight:normal;font-size:14.6px"
                                                   for="<?php echo $deactivate_reasons; ?>">
                                                <input type="radio" name="deactivate_plugin"
                                                       value="<?php echo $deactivate_reasons; ?>" required>
                                                <?php echo $deactivate_reasons; ?></label>
                                        </div>

                                        <?php } ?>
                                        <br>

                                        <textarea id="query_feedback" name="query_feedback" rows="4"
                                                  style="margin-left:2%"
                                                  cols="50" placeholder="Write your query here"></textarea>
                                        <tr>
                                            <td width="20%"><b>Email<span style="color: #ff0000;">*</span>:</b></td>
                                            <td><input type="email" name="feedback_email" required placeholder="Enter email to contact." style="width:55%"/></td>
                                        </tr>


                                        <?php
                                        foreach ( $tpostData['cid'] as $key ) { ?>
                                            <input type="hidden" name="result[]" value=<?php echo $key ?>>

                                        <?php } ?>


                                        <br><br>
                                        <div class="mojsp_modal-footer">
                                            <input type="submit" name="miniorange_feedback_submit"
                                                   class="button button-primary button-large" value="Submit"/>
                                        </div>
                                    </div>
                                </form>
                                <form name="f" method="post" action="" id="mojsp_feedback_form_close">
                                    <input type="hidden" name="option" value="mojsp_skip_feedback"/>
                                </form>

                            </div>
                            <script src="http://code.jquery.com/jquery-1.11.3.min.js"></script>
                            <script>


                                jQuery('input:radio[name="deactivate_plugin"]').click(function () {
                                    var reason = jQuery(this).val();
                                    jQuery('#query_feedback').removeAttr('required')

                                    if (reason == 'Facing issues During Registration') {
                                        jQuery('#query_feedback').attr("placeholder", "Could you please describe the issue in detail?");
                                    } else if (reason == "Not receving OTP During Registration") {
                                        jQuery('#query_feedback').attr("placeholder", "Could you please describe the issue in detail?");
                                    } else if (reason == "Does not have the features I'm looking for") {
                                        jQuery('#query_feedback').attr("placeholder", "Let us know what feature are you looking for");

                                    } else if (reason == "Bugs in the plugin") {
                                        jQuery('#query_feedback').attr("placeholder", "Could you please describe the bug in detail");

                                    } else if (reason == "Other Reasons") {
                                        jQuery('#query_feedback').attr("placeholder", "Could you let us know the reason for deactivation");
                                        jQuery('#query_feedback').prop('required', true);
                                    } else if (reason == "Not able to Configure") {
                                        jQuery('#query_feedback').attr("placeholder", "Not able to Configure? let us know so that we can improve the interface");
                                    }
                                });


                                // When the user clicks on <span> (x), mojsp_close the mojsp_modal
                                var span = document.getElementsByClassName("mojsp_close")[0];
                                span.onclick = function () {
                                    mojsp_modal.style.display = "none";
                                    jQuery('#mojsp_feedback_form_close').submit();

                                }


                            </script>
                            <style type="text/css">
                                .form-style-6 {
                                    font: 95% Arial, Helvetica, sans-serif;
                                    max-width: 400px;
                                    margin: 10px auto;
                                    padding: 16px;
                                    background: #F7F7F7;
                                }

                                .form-style-6 h1 {
                                    background: #43D1AF;
                                    padding: 20px 0;
                                    font-size: 140%;
                                    font-weight: 300;
                                    text-align: center;
                                    color: #fff;
                                    margin: -16px -16px 16px -16px;
                                }

                                .form-style-6 input[type="text"],
                                .form-style-6 input[type="date"],
                                .form-style-6 input[type="datetime"],
                                .form-style-6 input[type="email"],
                                .form-style-6 input[type="number"],
                                .form-style-6 input[type="search"],
                                .form-style-6 input[type="time"],
                                .form-style-6 input[type="url"],
                                .form-style-6 textarea,
                                .form-style-6 select {
                                    -webkit-transition: all 0.30s ease-in-out;
                                    -moz-transition: all 0.30s ease-in-out;
                                    -ms-transition: all 0.30s ease-in-out;
                                    -o-transition: all 0.30s ease-in-out;
                                    outline: none;
                                    box-sizing: border-box;
                                    -webkit-box-sizing: border-box;
                                    -moz-box-sizing: border-box;
                                    width: 100%;
                                    background: #fff;
                                    margin-bottom: 4%;
                                    border: 1px solid #ccc;
                                    padding: 3%;
                                    color: #555;
                                    font: 95% Arial, Helvetica, sans-serif;
                                }

                                .form-style-6 input[type="text"]:focus,
                                .form-style-6 input[type="date"]:focus,
                                .form-style-6 input[type="datetime"]:focus,
                                .form-style-6 input[type="email"]:focus,
                                .form-style-6 input[type="number"]:focus,
                                .form-style-6 input[type="search"]:focus,
                                .form-style-6 input[type="time"]:focus,
                                .form-style-6 input[type="url"]:focus,
                                .form-style-6 textarea:focus,
                                .form-style-6 select:focus {
                                    box-shadow: 0 0 5px #43D1AF;
                                    padding: 3%;
                                    border: 1px solid #43D1AF;
                                }

                                .form-style-6 input[type="submit"],
                                .form-style-6 input[type="button"] {
                                    box-sizing: border-box;
                                    -webkit-box-sizing: border-box;
                                    -moz-box-sizing: border-box;
                                    width: 100%;
                                    padding: 3%;
                                    background: #43D1AF;
                                    border-bottom: 2px solid #30C29E;
                                    border-top-style: none;
                                    border-right-style: none;
                                    border-left-style: none;
                                    color: #fff;
                                }

                                .form-style-6 input[type="submit"]:hover,
                                .form-style-6 input[type="button"]:hover {
                                    background: #2EBC99;
                                }


                            </style>

                            <?php
                            exit;
                        }
                    }
                }
            }

        }
    }

}