CREATE TABLE IF NOT EXISTS `#__miniorangesociallogin_customer_details` (
`id` int(11) UNSIGNED NOT NULL,

`email` VARCHAR(255)  NOT NULL ,
`password` VARCHAR(255)  NOT NULL ,
`hostname` VARCHAR(255)  NOT NULL ,
`admin_phone` VARCHAR(255)  NOT NULL ,
`customer_key` VARCHAR(255)  NOT NULL ,
`customer_token` VARCHAR(255) NOT NULL,
`api_key` VARCHAR(255)  NOT NULL,
`login_status` BOOLEAN NOT NULL,
`registration_status` VARCHAR(255) NOT NULL,
`new_registration`BOOLEAN NOT NULL,
`transaction_id` VARCHAR(255) NOT NULL,
`email_count` int(11),
`sms_count` int(11),
`uninstall_feedback` int(2) NOT NULL,
PRIMARY KEY (`id`)
) DEFAULT COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `#__miniorangesociallogin_apps_save` (
	`id` int(10) UNSIGNED NOT NULL,
	`fenable` BOOLEAN NOT NULL,`tenable` BOOLEAN NOT NULL,`genable` BOOLEAN NOT NULL,`lenable` BOOLEAN NOT NULL,`ienable` BOOLEAN NOT NULL, `venable` BOOLEAN NOT NULL, `round_enable` VARCHAR(255), `roundedge_enable` VARCHAR(255),`square_enable` VARCHAR(255), longbutton_enable VARCHAR(255), `default_enable` VARCHAR (255),
	`custom_enable` VARCHAR(255),`icon_size` int(11), `icon_width` int(11), `icon_height` int(11), `icon_curve` int(11), `background_color` VARCHAR(255),  
		PRIMARY KEY (`id`)
	
) DEFAULT COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `#__miniorangesociallogin_linked_user` (
`id` int(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`appname` varchar(20) NOT NULL,
`user_id` bigint(20) UNSIGNED NOT NULL,
`email` varchar(50) NOT NULL,
`identifier` varchar(100) NOT NULL,
`timestamp` timestamp default current_timestamp,
PRIMARY KEY (`id`),
FOREIGN KEY (`user_id`) REFERENCES `#_users`(`id`)
)DEFAULT COLLATE=utf8_general_ci;

INSERT IGNORE INTO `#__miniorangesociallogin_customer_details`(`id`,`hostname`,`login_status`) values (1,'https://login.xecurify.com',false) ;

INSERT IGNORE INTO `#__miniorangesociallogin_apps_save`(`id`,`fenable`, `tenable`, `genable`, `lenable`,`ienable`,`venable`, `round_enable`,`roundedge_enable`,`square_enable`,`longbutton_enable`,`default_enable`,`custom_enable`,`icon_size`,`icon_width`,`icon_height`,`icon_curve`,`background_color`) values (1,false,false,false,false,false,false,'round','RoundedEdge','square','Longbutton','default','custom',35,200,35,4,'FAF6F5') ;


