<?php
/**
 * Plugin Name: Social Login, Social Sharing by miniOrange
 * Plugin URI: http://miniorange.com
 * Description: Allow your users to login, comment and share with Facebook, Google, Twitter, LinkedIn etc using customizable buttons.
 * Version: 4.9.4
 * Author: miniOrange
 * Author URI: http://miniorange.com
 * License: GPL2
 */
defined('_JEXEC') or die();
JHtml::_('stylesheet', JUri::root() . 'media/com_miniorangesociallogin/css/miniorangesociallogin.css');
JHtml::_('script', JUri::root() . 'media/com_miniorangesociallogin/js/jscolor.js');
JHtml::_('script', JUri::root() . 'media/com_miniorangesociallogin/js/phone.js');
JHtml::_('stylesheet', JUri::root() . 'media/com_miniorangesociallogin/css/phone.css');
?>



<?php
if (! Mo_Sociallogin_Local_Util::is_curl_installed()) {
    ?>


<div id="help_curl_warning_title" class="mo_sociallogin_title_panel">
    <p>
        <a target="_blank" style="cursor: pointer;"><font color="#FF0000">Warning:
                PHP cURL extension is not installed or disabled. <span
                style="color: blue">Click here</span> for instructions to enable it.
        </font></a>
    </p>
</div>
<div hidden="" id="help_curl_warning_desc"
    class="mo_sociallogin_help_desc">
    <ul>
        <li>Step 1:&nbsp;&nbsp;&nbsp;&nbsp;Open php.ini file located under php
            installation folder.</li>
        <li>Step 2:&nbsp;&nbsp;&nbsp;&nbsp;Search for <b>extension=php_curl.dll</b></li>
        <li>Step 3:&nbsp;&nbsp;&nbsp;&nbsp;Uncomment it by removing the
            semi-colon(<b>;</b>) in front of it.
        </li>
        <li>Step 4:&nbsp;&nbsp;&nbsp;&nbsp;Restart the Apache Server.</li>
    </ul>
    For any further queries, please <a href="mailto:info@xecurify.com">contact
        us</a>.
</div>

<?php
}

$tab = "account";
if (isset($_GET['tab']) && ! empty($_GET['tab'])) {
    $tab = $_GET['tab'];
}

?>


<div class="form-horizontal" style="margin-top:70px;">
    <ul class="nav nav-tabs" id="myTabTabs">
        <li
            <?php

if ($tab == "account") {
    echo 'class="active"';
}
?>><a href="#account-setup" data-toggle="tab">Register/Login</a></li>
        <li
            <?php

if ($tab == "social_login") {
    echo 'class="active"';
}
?>><a href="#sociallogin" data-toggle="tab">Social login</a></li>
        <li
            <?php

if ($tab == "google_app") {
    echo 'class="active"';
}
?>><a href="#google_app_settings" data-toggle="tab">configure  Apps</a></li>

    <li
            <?php

if ($tab == "licensing") {
    echo 'class="active"';
}
?>><a href="#licensing" data-toggle="tab">Upgrade Plans</a></li>    



    </ul>
    <div class="tab-content" id="myTabContent">
        <div id="account-setup"
            class="tab-pane <?php if ($tab == 'account') {echo 'active';}?> ">
            <div class="row-fluid">
                <?php account_tab(); ?>
            </div>
        </div>
       <div id="sociallogin"
            class="tab-pane <?php if ($tab == 'social_login') { echo 'active';}?>">
            <div class="mo_saml_table_layout">
            <div class="row-fluid">

            <table style="width: 100%;">
                <tr>
                    <td style="width: 65%; vertical-align: top;" id="registrationForm">
                        <?php mo_sociallogin(); ?>
                    </td>
                    <td style="vertical-align: top; padding-left: 1%;">
                        <?php echo mo_sociallogin_local_support(); ?>
                    </td>

                </tr>
            </table>
        </div>
    </div>
    </div>
        <div id="custom_app_settings"
            class="tab-pane <?php

if ($tab == 'Custom_app') {
    echo 'active';
}
?>">         <div class="mo_saml_table_layout">
            <table style="width: 100%;">
                <tr>
                    <td style="width: 65%; vertical-align: top;"
                        class="configurationForm">
                        <?php

    mo_custom_app();
    ?>
                    </td>
                    <td style="vertical-align: top; padding-left: 1%;">
                        <?php echo mo_sociallogin_local_support(); ?>
                    </td>

                </tr>
            </table>
        </div>
    </div>

        <div id="google_app_settings"
             class="tab-pane <?php

             if ($tab == 'google_app') {
                 echo 'active';
             }
             ?>">
             <div class="mo_saml_table_layout">
            <table style="width: 100%;">
                <tr>
                    <td style="width: 65%; vertical-align: top;"
                        class="configurationForm">
                        <?php

                        mo_google_app();
                        ?>
                    </td>
                     <td style="vertical-align: top; padding-left: 1%;">
                        <?php echo mo_sociallogin_local_support(); ?>
                    </td>

                </tr>
            </table>
        </div>
    </div>
    <div id="licensing"
             class="tab-pane <?php

             if ($tab == 'licensing') {
                 echo 'active';
             }
             ?>">
             <div class="mo_saml_table_layout">
            <table style="width: 100%;">
                <tr>
                    <td style="width: 100%; vertical-align: top;"
                        class="configurationForm">
                        <?php

                        mo_joomla_social_licensing();
                        ?>
                    </td>

                </tr>
            </table>
        </div>
    </div>

       


    </div>
</div>

<?php
function mo_joomla_social_licensing(){
    $user_email = 'test@test.com';
    ?>

    <div class="mo_saml_table_layout_1">
        <h3>&emsp;&ensp;Upgrade Plans</h3><hr>
    <!-- Pricing Table Section -->
            <section id="pricing-table">
                <div class="container_1">
                    <div class="row">
                        <div class="pricing">
                            <div>
                                <div class="pricing-table class_inline_1">
                                    <div class="pricing-header" id="feature_list">
                                        <h2 class="pricing-title">Features / Plans</h2>
                                    </div>
                                    <div class="pricing-list">
                                        <ul>
                                            <li>Only 5  popular apps</li>
                                            <li>Preconfigured Apps ( No configuration required from you )</li>
                                            <li>More than 20 premium apps </li>
                                            <li>GDPR</li>
                                            <li>Domain Restriction</li>
                                            <li>Profile Completion</li>
                                            <li>Link Social accounts</li>
                                            <li>Recaptcha</li>
                                            <li>Extended User Attribute</li>   
                                            <li>End to End social login Integration*</li>
                                            <li>Support</li>                                                                   
                                        </ul>
                                    </div>
                                </div>                           
                            <div class="pricing-table class_inline">
                                <div class="pricing-header">
                                    <p class="pricing-title">FREE<br><br><span>5  popular apps</span></p>
                                    <p class="pricing-rate"><sup>$</sup> 0</sup></p>
                                    <div class="filler-class"></div>
                                    
                                </div>
                                <div class="pricing-list">
                                    <ul>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                        <li></li>
                                        <li></li>
                                        <li></li>
                                        <li></li>
                                        <li></li>
                                        <li></li>
                                        <li></li>                                    
                                                                         
                                        <li></li>                                    
                                        <li>Basic Email Support Available</li>                           
                                    </ul>
                                </div>
                            </div>
                        
                        
                        <div class="pricing-table class_inline">
                            <div class="pricing-header">
                               <p class="pricing-title">Premium<br><br>
                                <span>20+ Apps, Account linking, Recaptcha</span></p>
                                <p class="pricing-rate"><sup>$</sup>49</p>
                                <p style="font-size: 15px; color: #fff; text-align: center;margin-bottom:6px; ">Yearly Subscription Fees
                                
                                 <div class="filler-class-mo-gateway"></div>
                                  <a target="_blank" class="mo2f-pricing-button" href="<?php echo 'https://www.miniorange.com/contact';?>">Click here to upgrade</a>
                <br />
                                 
                            </div>
                            <div class="pricing-list">
                                <ul>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    
                                    <li>&#x2714;</li>   
                                    <li>Premium Email Support Available</li>                                                                    
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <h3>Steps to upgrade to premium module -</h3>
            <p>&emsp;&emsp;&emsp;1. You will be redirected to miniOrange Login Console. Enter your password with which you created an account with us. After that you will be redirected to payment page.</p>
            <p>&emsp;&emsp;&emsp;2. Enter your card details and complete the payment. On successful payment completion, you can download the premium plugin. Uninstall the free plugin and install the premium plugin.</p>
            
            <h4>* End to End <i>Social Login Integration</i> - We will setup a Conference Call / Gotomeeting and do end to end setup for you. We provide services to do the setup on your behalf.<br><br></h4>
        </div>
    </section>
    </div>


    <?php
}

function account_tab()
{
    ?>

<table style="width: 100%;">
    <tr class="mo_saml_table_layout">
        <td style="width: 65%; vertical-align: top;" id="registrationForm">
                <?php
    $customer_details = Mo_Sociallogin_Local_Util::getCustomerDetails();
    $login_status = $customer_details['login_status'];
    $registration_status = $customer_details['registration_status'];

    if ($login_status) {
        mo_sociallogin_local_login_page();
    } else if ($registration_status == 'MO_OTP_DELIVERED_SUCCESS' || $registration_status == 'MO_OTP_VALIDATION_FAILURE' || $registration_status == 'MO_OTP_DELIVERED_FAILURE') {
        mo_sociallogin_local_show_otp_verification();
    } else if (! Mo_Sociallogin_Local_Util::is_customer_registered()) {
        mo_sociallogin_local_registration_page();
    } else {
        mo_sociallogin_local_account_page();
    }
    ?>
            </td>
        <td style="vertical-align: top; padding-left: 1%;">
                <?php echo mo_sociallogin_local_support(); ?>
            </td>
    </tr>
</table>
<?php
}

/*
 * $db = JFactory::getDbo();
 * $query = $db->getQuery(true);
 * $query->select('login_status');
 * $query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
 * $query->where($db->quoteName('id')." = 1");
 *
 * $db->setQuery($query);
 * $login_status = $db->loadResult();
 * if(!$login_status){
 */
function mo_sociallogin_local_login_page()
{
    ?>
<div class="mo_saml_table_layout_1">
<form name="f" method="post" class="miniorange_saml_login_form"
    action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.verifyCustomer' ); ?>">
    <table class="mo_tfa_login_heading"><tr ><td>
                <p id="mo_tfa_register_login">Login with mini<span><b>O</b></span>range</p><td></tr></table>
                <hr>
    <input type="hidden" name="option1"
        value="mo_sociallogin_local_verify_customer" />
    <div class="mo_tfa_Login_panel">
                    <div class="alert alert-info" style="text-align: center;">One last step, login using your miniOrange account </div>
            <table class="mo_sociallogin_settings_table">
                <tr>
                    <td><b><font color="#FF0000">*</font>Email:</b></td>
                    <td><input class="mo_sociallogin_table_textbox" type="email"
                        name="email" required placeholder="person@example.com" value="" /></td>
                </tr>
                <tr>
                    <td><b><font color="#FF0000">*</font>Password:</b></td>
                    <td><input class="mo_sociallogin_table_textbox" required
                        type="password" name="password"
                        placeholder="Enter your miniOrange password" /></td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td><input type="submit" class="button button-primary button-large" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a
                        href="#cancel_link">Cancel</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <a href="#mo_sociallogin_local_forgot_password_link">Forgot your
                            password?</a></td>
                </tr>
            </table>
        </div>
    </div>


</form>

<form id="forgot_password_form" method="post"
    action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.forgotPassword' ); ?>">
    <input type="hidden" name="option1" value="user_forgot_password" />
</form>
<form id="cancel_form" method="post"
    action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.cancelform' ); ?>">
    <input type="hidden" name="option1" value="mo_sociallogin_local_cancel" />
</form>
<script>

        jQuery('a[href=#cancel_link]').click(function () {
            jQuery('#cancel_form').submit();
        });

        jQuery('a[href=#mo_sociallogin_local_forgot_password_link]').click(function () {
            jQuery('#forgot_password_form').submit();
        });
    </script>

<?php
}

function mo_google_app(){
    $app=JFactory::getApplication();
    $get=$app->input->get->getArray();
    if(isset($get['configure'])){
        mo_configure_apps($get['configure']);
        return;
    }
    // pull all active apps
        $db = JFactory::getDbo();

        $query = $db->getQuery( true );
        $query
            ->select('a.*')
            ->from($db->quoteName('#__miniorangesociallogin_apps_data','a'));
            
        $db->setQuery($query);
        $result = $db->loadObjectList();
        $activeApps = array();
        foreach ($result as $key => $value) {
            # code...
            $activeApps[$result[$key]->appName] = $result[$key]->active;
        }
        
        
    ?>
    <div class="mo_saml_table_layout_1">
        <form name="f" class="mo_social_facebook"  method='post'>
            <input type='hidden' name='google_custom_app_option' value='mo_sociallogin_google_custom_app' />
            
            <table class="mo_tfa_login_heading">


                <tr ><td>
                    <p id="mo_tfa_register_login">Select Your Application to configure</p></td></tr></table>
                    <hr>
            <table class="social_login_apps">
                <tr>
                    <td><a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=google'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/google.png' ?>"></a>
                        <div class="mo_tfa_configure_reconfigure_inactive radio_class" data-app-name="google" id="mo_social_toggle_google">
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div>
                    </td>
                    <td><a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=linkedin'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/linkedin.png' ?>"></a><div class="mo_tfa_configure_reconfigure_inactive radio_class" data-app-name="linkedin" id="mo_social_toggle_linkedin">
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div></td>
                        <td><a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=yahoo'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/yahoo.png' ?>"></a><div class="mo_tfa_configure_reconfigure_inactive radio_class"  data-app-name="yahoo" id="mo_social_toggle_yahoo">
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div></td>

                        <td ><a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=facebook'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/facebook.png' ?>"></a><div class="mo_tfa_configure_reconfigure_inactive radio_class" data-app-name="facebook" id="mo_social_toggle_facebook" >
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div></td>

                        
                </tr>
                <tr>
                    <td><a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=twitter'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/twitter.png' ?>"></a><div class="mo_tfa_configure_reconfigure_inactive radio_class" data-app-name="twitter" id="mo_social_toggle_twitter">
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div></td>
                </tr>
                <tr><th colspan="4" ><div class="mo_openid_highlight">
                    <h3 style="margin-left: 1%;line-height: 110%;color:white;">Premium Applications</h3>
                </div></th></tr>
                <tr>
                    
                    <td><a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=windowslive'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/windowslive.png' ?>"></a><div class="mo_tfa_configure_reconfigure_inactive radio_class" data-app-name="windowslive"  id="mo_social_toggle_windowslive">
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div></td>

                    <td><a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=instagram'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/insta.png' ?>"></a><div class="mo_tfa_configure_reconfigure_inactive radio_class" data-app-name="instagram" id="mo_social_toggle_instagram">
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div></td>
                        
                        <td>
                            <a href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app&configure=salesforce'); ?>"><img class="mo_social_icon_class" src="<?php echo JURI::root().'media/com_miniorangesociallogin/images/salesforce.png' ?>"></a><div class="mo_tfa_configure_reconfigure_inactive radio_class" data-app-name="salesforce" id="mo_social_toggle_salesforce">
                            <div class="mo_left-eye">
                            </div>
                            <div class="mo_right-eye" hidden="true">
                            </div>
                        </div></td>
                    </tr>
                    
            </table>
        </form>
    </div>
    <form name="mo_toggle_social_app" id="mo_toggle_social_app_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&task=myaccount.toggleSocialApp')  ?>">
        <input type="hidden" name="mo_app_name" id="mo_toggle_social_app_form_input" value=""/>
        <input type="hidden" name="mo_app_is_active" id="mo_is_activating_or_deactivating" value=""/>
        
    </form>

    <script>
        var isActive=0;

        <?php foreach ($activeApps as $key => $value) {if($value=='1')echo " var node = document.getElementById('mo_social_toggle_".$key."');node.setAttribute('class','mo_tfa_configure_reconfigure_active radio_class');node.children[0].hidden=true;node.children[1].hidden=false;";else echo "document.getElementById('mo_social_toggle_".$key."').setAttribute('class','mo_tfa_configure_reconfigure_inactive radio_class');"; } ?>
        jQuery('.radio_class').click(function () {
            if(this.getAttribute('class')=="mo_tfa_configure_reconfigure_inactive radio_class"){
                this.setAttribute('class',"mo_tfa_configure_reconfigure_active radio_class");
                isActive=1;
            }
            else{

                this.setAttribute('class',"mo_tfa_configure_reconfigure_inactive radio_class");
            }
            var childs=this.children;
            for(var i=0;i<childs.length;i++){
                
                childs[i].hidden=!childs[i].hidden;
                document.getElementById('mo_toggle_social_app_form_input').value=this.getAttribute('data-app-name');
                document.getElementById('mo_is_activating_or_deactivating').value=isActive;
                console.log(this.getAttribute('data-app-name'));
                document.getElementById('mo_toggle_social_app_form').submit();

              
            }

        });

        
    </script>
<?php
}



function mo_configure_apps($name){

    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
    $query->where($db->quoteName('id') . " = 1");

    $db->setQuery($query);
    $result = $db->loadAssoc();
    $query1 = $db->getQuery(true);
    $query1->select('*');
    $query1->from($db->quoteName('#__miniorangesociallogin_apps_data'));
    $query1->where($db->quoteName('appName') . " = ".$db->quote($name));
    $db->setQuery($query1);
    $appConfigData = $db->loadAssoc();

    if(is_null($appConfigData)){
        $appConfigData = array('clientId'=>'','clientSecret'=>'','scope'=>'','preconfigured'=>'0');
    }
    
     $isDisabled = 'disabled';
    if(isset($result['customer_token']) && !empty($result['customer_token']) & isset($result['customer_key']) && !empty($result['customer_key'])){
       $isDisabled = '';
    }
    $isPreconfigured ='';
    if($appConfigData['preconfigured']=='1'){
        $isPreconfigured = "checked='true'";
    }
    $appScopeList = array('facebook'=>'email, public_profile','google'=>'email+profile','twitter'=>'','instagram'=>'user_profile,user_media','linkedin'=>'r_liteprofile r_emailaddress w_member_social','yahoo'=>'openid email sdct-w','windowslive'=>'wl.emails,wl.basic,wl.photos,wl.contacts_photos','salesforce'=>'');
    $appConfigData['scope'] = empty($appConfigData['scope'])?$appScopeList[$name]:$appConfigData['scope'];
    
    ?>
    <div class="mo_saml_table_layout_1">
    <form name="f" class="mo_social_facebook"  method='post'  action=<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&task=myaccount.saveAppConfig');?> >
        <input type='hidden' name='google_custom_app_name' value=<?php echo $name;?> />
        
        <table class="mo_tfa_login_heading"><tr ><td>
                <p id="mo_tfa_register_login">Configure <?php echo ucfirst($name); ?> Application<span style="float:right;margin-right:-90px;"><a class="btn btn-sm btn-danger" href="<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&tab=google_app'); ?>"><b>X</b></a></span></p></td></tr></table>
                <hr>
        <div id="mo_configure_app_div" ><table id="mo_client_id_and_secret_table">
                <tr>
                    <td>
                        Client ID (<em>App ID</em>):
                    </td>
                    <td>
                        <input type='text' style='width: 200px' value="<?php echo $appConfigData['clientId']; ?>" name='app_client_id' <?php echo $isDisabled;?> />
                    </td>
                </tr>
                <tr>
                    <td>
                        Client Secret (<em>App Secret</em>):
                    </td>
                    <td>
                        <input type='text' style='width: 200px' value="<?php echo $appConfigData['clientSecret']; ?>" name='app_client_Secret' <?php echo $isDisabled;?>/>
                    </td>
                </tr>
                <tr>
                    <td>
                        Scope:
                    </td>
                    <td>
                        <input type='text' style='width: 200px' value="<?php echo $appConfigData['scope']; ?>" name='app_scope' <?php echo $isDisabled;?> />
                    </td>
                </tr>
                <tr>
                    <td> &nbsp; </td>
                    <td> &nbsp; </td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td><input type='submit' class='button button-primary button-large' value="Submit" <?php echo $isDisabled;?>/>
                    </td>

                </tr>
            </table>
            <table id="mo_use_preconfigured">
                <tr>
                    <td>&ensp;&ensp;<input type="checkbox" id="enablePreconfiguredCheckbox" style="vertical-align:bottom;" name="preconfigured" value="1" <?php echo $isDisabled;?> <?php echo $isPreconfigured;?> /><strong >&ensp;Use our preconfigured App</strong></td>
                </tr>
            </table>
        </div>
    </form>
    <form name="f1" id="mo_use_preconfigured_submit_form"  method='post'  action=<?php echo JRoute::_('index.php?option=com_miniorangesociallogin&task=myaccount.updatePreconfigureAppSettings');?> ><input type="hidden" name="enablePreconfiguredForAppName" value="<?php echo $name;?>" ><input type="hidden" id="mo_enable_preconfigured_app_value" value="" name="mo_enable_preconfigured_app"/></form>
    <script type="text/javascript">
        let element = document.getElementById('enablePreconfiguredCheckbox'); console.log(element);element.addEventListener('click',function(){
                if(element.checked){
                    document.getElementById('mo_enable_preconfigured_app_value').value='1';

                }
                else{
                    document.getElementById('mo_enable_preconfigured_app_value').value='0';                    
                }
            document.getElementById('mo_use_preconfigured_submit_form').submit();});</script>
    <br><br><br><br><br>


    <?php
    $arr=getInstructions($name);
    if(isset($arr[$name]))
        echo $arr[$name];
    if (! Mo_Sociallogin_Local_Util::is_customer_registered()) { ?>
        <script> jQuery(document).ready(function () {
                jQuery("#google_custom_app_form :input").prop("disabled", true);
            });</script><?php
    }


}

function getInstructions($name){
    $arrayName = array( 
        'google' =>'<div class="mo_social_facebook" >
            <br><strong>Instructions to configure Google: </strong>
            <ol><li>Visit the Google website for developers <a href="https://console.developers.google.com/project"target="_blank">console.developers.google.com</a>.</li><li>Open the Google API Console Credentials page and go to API Manager -> Credentials</li><li>From the project drop-down, click on + to Create a new project, enter a name for the project, and optionally, edit the provided Project ID. Click Create.</li><li>On the Credentials menu, select Create credentials, then select OAuth client ID.</li><li>You may be prompted to set a product name on the Consent screen. If so, click Configure consent screen, supply the requested information, and click Save to return to the Credentials screen.</li><li>Select Web Application for the Application Type. Enter <b>'.JURI::root().'?openidcallback=google</b> in Authorized redirect URIs.</li><li>Click Create.</li><li>On the page that appears, copy the client ID and client secret to your clipboard, as you will need them to configure above.</li><li>Enable the Google+ API.<ul><li>In the Dashboard menu, click on ENABLE APIS AND SERVICES.</li><li>Type Google+ in search box, select Google+ API and click on Enable.</li></ul></li><li>Go to Social Login tab to configure the display as well as other login settings.</li></ol><br></div>',
        'facebook'=>'<div class="mo_social_facebook" >
    <br><strong>Instructions to configure Facebook : </strong>
            <ol>
                <li>Go to Facebook developers console <a href="https://developers.facebook.com/apps/" target="_blank">https://developers.facebook.com/apps/</a>. Login with your facebook developer account</li>
                <li>Click on <b>Add a New App</b> button</li>
                <li>Enter <b>Display Name</b> and click on Create App ID</li>
                <li>Click on <b>Products</b> from left pane of the page and select <b>Facebook Login</b> and click on <b>Set Up</b> button</li>
                <li>Click on <b>Web</b>. Enter <b>
    <?php echo JURI::root();?>
     </b> into <i><u>Site URL</u></i> than click on <b> Save</b>.</li>
                <li>Goto <b>Settings -> Basic</b> from left pane of the page, Enter <i><u>Privacy Policy URL</u></i> and  Choose a Category form <b>Category</b> dropdown then click on <b>Save Changes</b></li>
                <li>From the left pane, select <b>Facebook Login -> Settings</b>.</li>
                <li>Under Client OAuth Settings section, Enter <b>'.JURI::root().'?openidcallback=facebook</b> in <i><u>Valid OAuth Redirect URIs</u></i> and click on <b>Save Changes</b> button.</li>
                <li>Change your app status from In Development to Live by clicking on OFF (sliding button) beside Status option of the top right corner. Then, click on confirm button.</li>
                <li>Goto <b>Settings -> Basic</b> from left pane of the page, Copy <i><u>App ID</u></i> and <i><u>App Secret</u></i> provided by Facebook and past it in <i><u>Client ID</u></i> and <i><u>Client Secret</u></i> field under <b>Custom App</b> Tab of the miniOrange Social Login plugin.</li>
                <li>Click on the Submit button.</li>
                <li>Go to <b>Social Login tab</b> to configure the display as well as other login settings.</li>
            </ol><br></div>',
        'twitter' =>'<div class="mo_social_facebook">
    <br><strong>Instructions to configure Twitter : </strong>
    <ol><li>Go to <a href="https://apps.twitter.com/" target="_blank">https://apps.twitter.com/</a> and sign in with your twitter account.</li><li>Click on <b>Create New App</b>.</li> <li>Enter Name, description, website name and callback URL.</li><li><b>Callback URL</b> <br><u>Example of public website, </u><br>if your website URL is => <b><i>'.JURI::root().' </i></b><br> then your callback URL should be => <b><i>'.JURI::root().'<i></b><br><u>Example of localhost,</u><br> Twitter may not accept local IPs so try using 127.0.0.1 instead of localhost.<br> Also make sure your Callback URL is prefixed with the website.  <br> Go to Settings-> General and replace "localhost" with "127.0.0.1" in <b>Joomla Address (URL)</b> and <b>Site Address (URL)</b> <br>if your website URL is => http://127.0.0.1/joomla <br> then your callback URL should be => http://127.0.0.1/joomla</li><li>Twitter might ask you to add your phone number to your profile while creating the app.</li><li>Check the developer agreement checkbox and click on <b>Create your Twitter Application</b>.Under <b>Keys and Access Token</b> Tab, you will find your <b>API Key/Secret</b>.Paste them into the fields above.</li><li><u>Instructions to request email address of a user</u>: The â€œRequest email addresses from usersâ€ checkbox is available under the app permissions on apps.twitter.com. Privacy Policy URL and Terms of Service URL fields must be completed in the app settings in order for email address access to function. If enabled, users will be informed via the oauth/authorize dialog that your app can access their email address.If the user does not have an email address on their account, or if the email address is not verified, email will not be returned.</li><li>Go to Permissions tab -> Access. Select <b>Read Only</b> type of access.</li><li>Click on the Update settings button.</li><li>Go to Social Login tab to configure the display as well as other login settings.</li></ol>
    <br></div>',
    'linkedin'=>'<div class="mo_social_facebook">
    <br><strong>Instructions to configure Linkedin: </strong>
    <ol><li>Go to <a href="http://developer.linkedin.com/" target=\"_blank\">http://developer.linkedin.com/</a> and click on <strong>Create Apps</strong> and sign in with your linkedin account.</li><li>Enter the Application Name, Company Name, Privacy Policy URL, Business Email And upload app logo.</li> <li>Enter Name, description, website name and callback URL.</li><li>Check the <b>API Terms of Use</b> and click on create app.</li><li>Click on Auth and enter Redirect URLs <b>'.JURI::root().'?openidcallback=linkedin </b>and click on <strong>Update</strong></li><li>On the same page you will be able to see your <strong>Client ID</strong> and <strong>Client Secret</strong> under the <strong>Application credentials</strong> section. Copy these and Paste them into the fields above.</li><li>If you want to access the full profile of LinkedIn user, you need to fill this form to become a LinkedIn partner and make sure your app conforms to terms of usage specified here . Once your app is approved by Linkedin, update the scope to <b>r_emailaddress,r_fullprofile,r_contactinfo</b>. If your app is not approved or is in the process of getting approved, let the scope be <b>r_liteprofile r_emailaddress w_member_social</b>.</li><li>Click on the Save settings button.</li><li>Go to Social Login tab to configure the display as well as other login settings.</li></ol>
    <br></div>',
    'instagram'=>'<div class="mo_social_facebook">
    <br><strong>Instructions to configure Instagram: </strong>
    <ol><li>Go to <a href="http://instagram.com/developer" target=\"_blank\">http://instagram.com/developer</a> and sign in with your instagram account.</li><li>Go to Manage Clients and click on <strong>Register A New Client</strong></li><li>Enter Application Name, Description, Company Name, Privacy Policy URL, Contact Email.</li><li>Enter the URL As <strong>Website URL.</strong> And URL as <strong>Valid redirect URI.</strong></li><li>Click on <strong>Register</strong>.</li><li>Once your app is registered, you will be navigated to the <strong>Manage Clients</strong> page. Click on the <strong>Manage</strong> button for your new client.</li><li>This will bring you to the page that contains your <strong>Client ID</strong> and <strong>Client Secret</strong>. Copy these and Paste them into the fields above. ##Go to <b>Permissions</b> tab and click on <b>Start a Submission</b> </li><li>Click on the Save settings button.</li><li>Go to Social Login tab to configure the display as well as other login settings</li></ol>
    <br></div>',
    'yahoo'=>'<div class="mo_social_facebook">
    <br><strong>Instructions to configure Yahoo: </strong>
    <ol><li>Go to <a href="https://developer.yahoo.com" target=\"_blank\">https://developer.yahoo.com</a> Sign in with your yahoo account and select Apps from the menubar.</li><li>On the page, Click on the <strong>Create an App</strong> button.</li><li>Enter <strong>Application Name</strong> and select <strong>Application Type</strong> as <strong>Web Application</strong>.</li><li>Enter URL <b>'.JURI::root().'</b> in the <strong>Home Page URL</strong>.</li><li>Enter URL <b>'.JURI::root().'</b> in the <b>Redirect URI(s) </b></b></li><li>Select all <b>API Permissions</b>.</li><li>Click on <strong>Create App</strong>.</li><li>Copy the <b>Client ID</b> and <b>Client Secret</b> from this page and Paste them into the fields above.</li><li>Keep <b>Scope</b> blank. </li><li>Click on the <b>Save settings</b> button.</li><li>Go to Social Login tab to configure the display as well as other login settings</li></ol>
    <br></div>',
    'windowslive'=>'<div class="mo_social_facebook">
    <br><strong>Instructions to configure Windowslive: </strong>
    <ol><li>Go to <a href="https://apps.dev.microsoft.com/" target=\"_blank\">https://apps.dev.microsoft.com/</a> and sign in with your windows account.</li><li>Click on Add an app in Azure Portal.</li><li>Sign in with your Microsoft azure account.</li><li>Click on <b>New Registration tab</b>.</li><li>Name your new app and select Accounts in any organizational directory as supported accounts types . click on <b>Register</b>.</li><li>Click on <strong>Authentication</strong> from left side menu.  </li><li>Enter URL as Redirect URL.<strong>Copy the Client ID from the Overview tab.</strong>. This is your <b>Client ID </b>.</li><li>Go to Certificates and Security tab.</li><li>Click on <b>New Client Sceret</b>. Copy your password. This is your <b>Client Secret</b>.</li><li>Scroll down to <strong>Advanced Options</strong> and make sure <strong>Live SDK support</strong> is checked.</li><li>Click on the Save button.</li><li>Copy the client ID and client secret to your clipboard, as you will need them to configure above. </li><li>Click on the Save settings button.</li><li>Go to Social Login tab to configure the display as well as other login settings.</li></ol>
    <br></div>'
     );
    
return $arrayName;
}



function mo_custom_app()
{
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
    $query->where($db->quoteName('id') . " = 1");

    $db->setQuery($query);
    $default_config = $db->loadAssoc();
    $client_id = isset($default_config['client_id']) ? $default_config['client_id'] : '';
    $client_secret = isset($default_config['client_Secret']) ? $default_config['client_Secret'] : '';

    ?>
    <div class="mo_saml_table_layout_1">

    <form name='miniorange_saml_login_form' id='custom_app_form' method='post' action=" <?php echo JRoute::_('index.php?option=com_miniorangesociallogin&task=myaccount.saveConfig');?> ">
            <input type='hidden' name='custom_app_option' value='mo_sociallogin_custom_app' />
            <table class="mo_tfa_login_heading"><tr ><td>
                <p id="mo_tfa_register_login">facebook Appication</p><td></tr></table>
                <hr>
                  <div class="mo_social_facebook"><table >
                     
                      <tr>
                        <td>
                            Client ID (<em>App ID<em>):
                        </td>
                        <td>
                            <input type='text' style='width: 400px' name='client_id' value='<?php echo $client_id; ?>'>
                        </td>
                      </tr>
                      <tr>
                        <td>
                            Client Secret (<em>App Secret<em>):
                        </td>
                        <td>
                            <input type='text' style='width: 400px' name='client_Secret' value='<?php echo $client_secret; ?>'>
                        </td>
                      </tr>
                      <tr>
                      <td> &nbsp; </td>
                      <td> &nbsp; </td>
                       </tr>
                      <tr>
                            <td>&nbsp;</td>
                            <td><input type='submit' class='button button-primary button-large' value="Submit"/>
                            </td>
                        </tr>
                  </table>
                  </div>
                  </form>
                  
    <?php 
    if (! Mo_Sociallogin_Local_Util::is_customer_registered()) { ?>
     <script> jQuery(document).ready(function () {
            jQuery("#custom_app_form :input").prop("disabled", true);        
        });</script><?php 
    }
}

function mo_sociallogin()
{
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from($db->quoteName('#__miniorangesociallogin_apps_save'));
    $query->where($db->quoteName('id') . " = 1");

    $db->setQuery($query);
    $default_config = $db->loadAssoc();

    ?>
    
        <div class="mo_saml_table_layout_1">
    <form class="miniorange_saml_login_form" 
    action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.saveConfig' ); ?>" method="post" name="adminForm" id="adminForm">
     <table class="mo_tfa_login_heading"><tr ><td>
                <p id="mo_tfa_register_login">Social login app settings</p><td></tr></table>
                <hr>
    
           <input id="mo_ldap_local_configuration_form_action" type="hidden"
          name="option1" value="mo_sociallogin_save_config" />


        <div id="main-div" style="float: left; width: 70%; position: relative;">


        <!-- social login -->



        <div id="customization-div"
            style="float: left; width: 70%; white-space: nowrap;">
            <h3>Customization:</h3>
            <table name="try-table">
                <tbody style="vertical-align: top;">
                    <tr>
                        <td><div id="shape-div" style="float: left; width: fit-content;">
                                <b>Shape:</b> <br> <input type="radio" name="mo_shape"
                                    id="round_enable" value="round" onclick="sizeOfIcon();"
                                    <?php

    if ($default_config['round_enable'] == 'round') {
        echo 'checked="true"';
    }
    ?> />&nbsp;Round <br> <input type="radio" name="mo_shape"
                                    id="roundedge_enable" value="RoundedEdge"
                                    onclick="sizeOfIcon();"
                                    <?php

    if ($default_config['roundedge_enable'] == 'RoundedEdge') {
        echo 'checked="true"';
    }
    ?> />&nbsp;Rounded Edge <br> <input type="radio" name="mo_shape"
                                    id="square_enable" value="square" onclick="sizeOfIcon();"
                                    <?php

    if ($default_config['square_enable'] == 'square') {
        echo 'checked="true"';
    }
    ?> />&nbsp;Square <br> <input type="radio" name="mo_shape"
                                    id="longbutton_enable" value="longbutton"
                                    onclick="sizeOfIcon();"
                                    <?php

    if ($default_config['longbutton_enable'] == 'longbutton') {
        echo 'checked="true"';
    }
    ?> />&nbsp;Long Button with Text
                            </div></td>

                        <td>
                            <div id="background-div"
                                style="float: left; width: fit-content; padding-left: 70px;">

                                <b>Background:</b><br> <input type="radio" name="mo_background"
                                    id="default_enable" value="default"
                                    <?php

    if ($default_config['default_enable'] == 'default') {
        echo 'checked="true"';
    }
    ?> />&nbsp;Default<br> <input type="radio" name="mo_background"
                                    id="custom_enable" value="custom"
                                    <?php

    if ($default_config['custom_enable'] == 'custom') {
        echo 'checked="true"';
    }
    ?> />&nbsp;Custom<br> <input id="mo_login_icon_custom_color"
                                    style="width: 135px; color: rgb(255, 255, 255); background-image: none; background-color: rgb(43, 65, 255);"
                                    name="mo_login_icon_custom_color" class="color"
                                    value="<?php echo $default_config['background_color']; ?>"
                                    autocomplete="on">
                            </div>
                        </td>
                        <td>
                            <div id=size-container>
                                <b>Size of icon:&nbsp;&nbsp;</b>
                                <div hidden id="size_of_icon">
                                    Size: <input id="mo_login_size_plus" type="button" value="+"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_size').value ,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_custom_boundary').value)">
                                    <input id="mo_login_size_minus" type="button" value="-"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_size').value ,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_custom_boundary').value)">
                                    <input id="mo_login_icon_size"
                                        onkeyup="moLoginSizeValidate(this)"
                                        name="mo_login_icon_custom_size" type="text"
                                        value="<?php echo $default_config['icon_size']; ?>">
                                </div> 
                
                                    <?php //echo $default_config['icon_width']-29; exit; ?>
                                   <div hidden id="width">
                                    Width: <input id="mo_login_width_plus" type="button" value="+"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_width').value ,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_height').value,document.getElementById('mo_login_icon_custom_boundary').value)">
                                    <input id="mo_login_width_minus" type="button" value="-"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_width').value ,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_height').value,document.getElementById('mo_login_icon_custom_boundary').value)">

                                    <input id="mo_login_icon_width"
                                        onkeyup="moLoginHeightValidate(this)"
                                        name="mo_login_icon_custom_width" type="text"
                                        value="<?php echo $default_config['icon_width']; ?>">
                                </div>
                                <div hidden
                    id="height">
                                    Height: <input id="mo_login_height_plus" type="button"
                                        value="+"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_width').value,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_height').value,document.getElementById('mo_login_icon_custom_boundary').value)">
                                    <input id="mo_login_height_minus" type="button" value="-"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_width').value,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_height').value,document.getElementById('mo_login_icon_custom_boundary').value)">

                                    <input id="mo_login_icon_height"
                                        onkeyup="moLoginHeightValidate(this)"
                                        name="mo_login_icon_custom_height" type="text"
                                        value="<?php echo $default_config['icon_height'] ?>">
                                </div>
                                <div hidden id="curve">
                                    Curve: <input id="mo_login_boundary_plus" type="button"
                                        value="+"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_width').value,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_height').value,document.getElementById('mo_login_icon_custom_boundary').value)" />
                                    <input id="mo_login_boundary_minus" type="button" value="-"
                                        onmouseup="moLoginPreview(document.getElementById('mo_login_icon_width').value,setLoginTheme(),setLoginCustomTheme(),document.getElementById('mo_login_icon_custom_color').value,document.getElementById('mo_login_icon_space').value,document.getElementById('mo_login_icon_height').value,document.getElementById('mo_login_icon_custom_boundary').value)" />
                                    <input id="mo_login_icon_custom_boundary"
                                        onkeyup="moLoginHeightValidate(this)"
                                        name="mo_login_icon_custom_curve" type="text"
                                        value="<?php echo $default_config['icon_curve']; ?>">
                                </div>
                            </div>
                    
                        </td>


                        <td><br><input type="submit" class="btn btn-medium btn-success"
                            value="Save" /></td>
                        </tr>
                </tbody>

            </table>
        </div>

    </div>

       
        <span
            style="display: inline-block; color: black; background-color: rgba(251, 230, 0, 0.15); padding: 8px; border: solid 1px rgba(255, 0, 9, 0.36); margin-right: 20px;">
            <b>Please note:</b> To position social network icons, go to <b>Extensions
                >> Modules</b>. Click on <b>MiniOrange Social Login</b> to edit the
            module. Under <b>Module</b> tab, select position from the <b>Position</b>
            dropdown and set <b>Status</b> as <b>Published</b>. In <b>Menu
                Assignment</b> tab, select the pages where you want to display the
            icons. Click on <b>Save & Close</b> button.
        </span>
     <br><br>
    </div>
<br>
</form>

</div>
<script>


        <?php if (! Mo_Sociallogin_Local_Util::is_customer_registered()) { ?>
        jQuery(document).ready(function () {
            jQuery("#adminForm :input").prop("disabled", true);
            //  jQuery("#mo_wpns_enable_unusual_activity_email_to_user :input").prop("disabled", true);
        });

        <?php } ?>
        <?php
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from($db->quoteName('#__miniorangesociallogin_apps_save'));
    $query->where($db->quoteName('id') . " = 1");

    $db->setQuery($query);
    $default_config = $db->loadAssoc();

    ?>
        jQuery(document).ready(function () {
                sizeOfIcon();
            }
        );

        function sizeOfIcon() {

            if ((jQuery('input[name=mo_shape]:checked', '#adminForm').val()) === 'longbutton') {

                jQuery("#width").show('block');
                jQuery("#height").show('block');
                jQuery("#curve").show('block');
                jQuery("#size_of_icon").hide();
            } else {

                jQuery("#width").hide();
                jQuery("#height").hide();
                jQuery("#curve").hide();
                jQuery("#size_of_icon").show('block');
            }

        }


    </script>



<!-- End social login -->

<!-- social share -->

<script>

        function moLoginWidthIncrement(e, t, r, a, i) {
            var h, s, c = !1, _ = a;
            s = function () {
                "add" == t && r.value < 1000 ? r.value++ : "subtract" == t && r.value > 140 && r.value--, h = setTimeout(s, _), _ > 20 && (_ *= i), c || (document.onmouseup = function () {
                    clearTimeout(h), document.onmouseup = null, c = !1, _ = a
                }, c = !0)
            }, e.onmousedown = s
        }

        function moLoginHeightIncrement(e, t, r, a, i) {
            var h, s, c = !1, _ = a;
            s = function () {
                "add" == t && r.value < 50 ? r.value++ : "subtract" == t && r.value > 35 && r.value--, h = setTimeout(s, _), _ > 20 && (_ *= i), c || (document.onmouseup = function () {
                    clearTimeout(h), document.onmouseup = null, c = !1, _ = a
                }, c = !0)
            }, e.onmousedown = s
        }

        function moLoginBoundaryIncrement(e, t, r, a, i) {
            var h, s, c = !1, _ = a;
            s = function () {
                "add" == t && r.value < 25 ? r.value++ : "subtract" == t && r.value > 0 && r.value--, h = setTimeout(s, _), _ > 20 && (_ *= i), c || (document.onmouseup = function () {
                    clearTimeout(h), document.onmouseup = null, c = !1, _ = a
                }, c = !0)
            }, e.onmousedown = s
        }

        function moLoginIncrement(e, t, r, a, i) {
            var h, s, c = !1, _ = a;
            s = function () {
                "add" == t && r.value < 60 ? r.value++ : "subtract" == t && r.value > 20 && r.value--, h = setTimeout(s, _), _ > 20 && (_ *= i), c || (document.onmouseup = function () {
                    clearTimeout(h), document.onmouseup = null, c = !1, _ = a
                }, c = !0)
            }, e.onmousedown = s
        }

        moLoginIncrement(document.getElementById('mo_login_size_plus'), "add", document.getElementById('mo_login_icon_size'), 300, 0.7);
        moLoginIncrement(document.getElementById('mo_login_size_minus'), "subtract", document.getElementById('mo_login_icon_size'), 300, 0.7);
        moLoginWidthIncrement(document.getElementById('mo_login_width_plus'), "add", document.getElementById('mo_login_icon_width'), 300, 0.7);
        moLoginWidthIncrement(document.getElementById('mo_login_width_minus'), "subtract", document.getElementById('mo_login_icon_width'), 300, 0.7);
        moLoginHeightIncrement(document.getElementById('mo_login_height_plus'), "add", document.getElementById('mo_login_icon_height'), 300, 0.7);
        moLoginHeightIncrement(document.getElementById('mo_login_height_minus'), "subtract", document.getElementById('mo_login_icon_height'), 300, 0.7);
        moLoginBoundaryIncrement(document.getElementById('mo_login_boundary_plus'), "add", document.getElementById('mo_login_icon_custom_boundary'), 300, 0.7);
        moLoginBoundaryIncrement(document.getElementById('mo_login_boundary_minus'), "subtract", document.getElementById('mo_login_icon_custom_boundary'), 300, 0.7);

        function setLoginTheme() {
            return jQuery('input[name=mo_shape]:checked', '#form-apps').val();
        }

        function setLoginCustomTheme() {
            return jQuery('input[name=mo_background]:checked', '#form-apps').val();
        }

        function setSizeOfIcons() {

            if ((jQuery('input[name=mo_shape]:checked', '#form-apps').val()) == 'longbutton') {
                return document.getElementById('mo_login_icon_width').value;

            } else {
                return document.getElementById('mo_login_icon_size').value;
            }
        }


    </script>

<?php
}

function mo_sociallogin_local_account_page()
{
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
    $query->where($db->quoteName('id') . " = 1");

    $db->setQuery($query);
    $result = $db->loadAssoc();

    $email = $result['email'];
    $customer_key = $result['customer_key'];
    $api_key = $result['api_key'];
    $customer_token = $result['customer_token'];
    $hostname = $result['hostname'];

    ?>
    <div class="mo_saml_table_layout_1">
          <table class="mo_tfa_login_heading"><tr ><td>
                <p id="mo_tfa_register_login"class="mo_saml_welcome_message">Thank You for registering with miniOrange.</p></td></tr></table>
                <hr>
<div
    style="background-color: #FFFFFF; border: 0px solid #CCCCCC; padding: 0px 0px 0px 10px; width: 98%; height: 344px">
    <div>

        <h3>Your Profile:</h3>
        <table border="1"
            style="background-color: #FFFFFF; border: 1px solid #CCCCCC; border-collapse: collapse; padding: 0px 0px 0px 10px; margin: 2px; width: 85%">
            <tr>
                <td style="width: 45%; padding: 10px;">Username/Email</td>
                <td style="width: 55%; padding: 10px;"><?php echo $email ?></td>
            </tr>
            <tr>
                <td style="width: 45%; padding: 10px;">Customer ID</td>
                <td style="width: 55%; padding: 10px;"><?php echo $customer_key ?></td>
            </tr>

        </table>
        

<?php
}

/* Show OTP verification page */
function mo_sociallogin_local_show_otp_verification()
{
    ?>
<div class="mo_saml_table_layout_1">
   
        
            <!-- Enter otp -->
            <form name="f" method="post"  class="miniorange_saml_login_form"
                action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.validateOtp' ); ?>">
                 <table class="mo_tfa_login_heading"><tr ><td>
                <p id="mo_tfa_register_login">Verify your Email</p><td></tr></table>
                <hr>
                <table class="mo_sociallogin_settings_table">
                <input type="hidden" name="option1"
                    value="mo_sociallogin_local_validate_otp" />
                <h3>Verify Your Email</h3>
                <tr>
                    <td><b><font color="#FF0000">*</font>Enter OTP:</b></td>
                    <td colspan="2"><input class="mo_sociallogin_table_textbox"
                        autofocus="true" type="text" name="otp_token" required
                        placeholder="Enter OTP" style="width: 61%;"
                        pattern="[0-9]{4,8}|[a-zA-Z]{32,48}" /> &nbsp;&nbsp;<a
                        style="cursor: pointer;"
                        onclick="document.getElementById('resend_otp_form').submit();">Resend
                            OTP over Email</a></td>
                </tr>
                <tr>
                    <td colspan="3"></td>
                </tr>
                <tr>
                    <td></td>
                    <td><input type="button" value="Back" id="back_btn"
                        class="btn btn-danger btn-medium" /> <input type="submit"
                        value="Validate OTP" class="btn btn-success btn-medium" />
                    </td>
            
            </form>
            <td>
                <form method="post"
                    action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.cancelform' ); ?>"
                    id="mo_sociallogin_cancel_form">
                    <input type="hidden" name="option1"
                        value="mo_sociallogin_local_cancel" />
                </form>
            </td>
            </tr>
            <form name="f" id="resend_otp_form" method="post"
                action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.resendOtp' ); ?>">
                <td><input type="hidden" name="option1"
                    value="mo_sociallogin_local_resend_otp" /></td>
                </tr>
            </form>
        </table>
        <br>
        <hr>

        <h3>I did not recieve any email with OTP . What should I do ?</h3>
        <form id="phone_verification" method="post"
            action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.phoneVerification' ); ?>">
            <input type="hidden" name="option1"
                value="mo_sociallogin_local_phone_verification" /> If you can't see
            the email from miniOrange in your mails, please check your <b>SPAM
                Folder</b>. If you don't see an email even in SPAM folder, verify
            your identity with our alternate method. <br> <br> <b>Enter your
                valid phone number here and verify your identity using one time
                passcode sent to your phone.</b><br> <br> <input
                class="mo_sociallogin_table_textbox" required="true"
                pattern="[\+]\d{1,3}\d{10}" autofocus="true" type="text"
                name="phone_number" id="phone" placeholder="Enter Phone Number"
                style="width: 220px !important; height: 30px !important; padding-left: 41px !important;"
                title="Enter phone number without any space or dashes." /> <br> <input
                type="submit" value="Send OTP"
                class="btn btn-primary btn-medium" />

        </form>
   
</div>
<script>
        jQuery("#phone").intlTelInput();
        jQuery('#back_btn').click(function () {
            jQuery('#mo_sociallogin_cancel_form').submit();
        });

    </script>
<?php
}

/* End Show OTP verification page */

/* Create Customer function */
function mo_sociallogin_local_registration_page()
{
    
    ?>

<!--Register with miniOrange-->
<div class="mo_saml_table_layout_1">
    <form name="f" class="miniorange_saml_login_form" method="post"
    action="<?php echo JRoute::_( 'index.php?option=com_miniorangesociallogin&task=myaccount.registerCustomer' ); ?>">
    <table class="mo_tfa_login_heading"><tr ><td>
                <p id="mo_tfa_register_login">Register with mini<span><b>O</b></span>range</p><td></tr></table>
                <hr>
    <input type="hidden" name="option1"
        value="mo_sociallogin_local_register_customer" />
    <p class="alert alert-info" style="text-align: center;margin-right:25px;" >Please enter a valid email id that you have access to. You will be
        able to move forward after verifying an OTP that we will send to this
        email.</p>
    
    <div class="mo_tfa_Login_panel" style="min-height: 274px;">
        <div id="panel1">
            <table class="mo_sociallogin_settings_table">
                <tr>
                    <td><b><font color="#FF0000">*</font>Email:</b></td>
                    <td>
                            <?php

    $current_user = JFactory::getUser();
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
    $query->where($db->quoteName('id') . " = 1");

    $db->setQuery($query);
    $result = $db->loadAssoc();
    $admin_email = $result['email'];
    $admin_phone = $result['admin_phone'];
    if ($admin_email == '') {
        $admin_email = $current_user->email;
    }

    ?>
                            <input class="mo_sociallogin_table_textbox"
                        type="email" name="email" required
                        placeholder="person@example.com"
                        value="<?php echo $admin_email; ?>" />
                    </td>
                </tr>
                <tr>
                    <td><b>Phone number:</b></td>
                    <td><input 
                        style="width: 220px !important; height: 30px !important; padding-left: 41px !important;"
                        type="tel" id="phone"
                        pattern="[\+]\d{11,14}|[\+]\d{1,4}([\s]{0,1})(\d{0}|\d{9,10})"
                        name="phone" title="Phone with country code eg. +1xxxxxxxxxx"
                        placeholder="Phone with country code eg. +1xxxxxxxxxx"
                        value="<?php echo $admin_phone; ?>" /> <i>We will call only if you
                            call for support</i><br> <br></td>
                </tr>

                <tr>
                    <td><b><font color="#FF0000">*</font>Password:</b></td>
                    <td><input  required
                        type="password" name="password"
                        placeholder="Choose your password (Min. length 6)" /></td>
                </tr>
                <tr>
                    <td><b><font color="#FF0000">*</font>Confirm Password:</b></td>
                    <td><input  required
                        type="password" name="confirmPassword"
                        placeholder="Confirm your password" /></td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td><input type="submit" value="Register"
                        class="btn btn-medium btn-success" /></td>
                </tr>
            </table>
        </div>
    </div>
</form>


<script>
        jQuery("#phone").intlTelInput();
    </script>

<?php
}

?>

