<?php

/**
 * @version    CVS: 1.0.0
 * @package    com_miniorangesociallogin
 * @author     miniOrange Security Software Pvt. Ltd. <info@xecurify.com>
 * @copyright  Copyright 2015 miniOrange. All Rights Reserved.
 * @license    GNU/GPLv3
 */
defined('_JEXEC') or die;

/**
 * Class MiniorangesocialloginFrontendHelper
 *
 * @since  1.6
 */
class MiniorangesocialloginHelpersMiniorangesociallogin
{
	/**
	 * Get an instance of the named model
	 *
	 * @param   string  $name  Model name
	 *
	 * @return null|object
	 */
	public static function getModel($name)
	{
		$model = null;

		// If the file exists, let's
		if (file_exists(JPATH_SITE . '/components/com_miniorangesociallogin/models/' . strtolower($name) . '.php'))
		{
			require_once JPATH_SITE . '/components/com_miniorangesociallogin/models/' . strtolower($name) . '.php';
			$model = JModelLegacy::getInstance($name, 'MiniorangesocialloginModel');
		}

		return $model;
	}
}
