<?php 
/*------------------------------------------------------------------------
# mod_SocialLoginandSocialShare
# ------------------------------------------------------------------------
# author    LoginRadius inc.
# copyright Copyright (C) 2013 loginradius.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.loginradius.com
# Technical Support:  Forum - http://community.loginradius.com/
-------------------------------------------------------------------------*/

//no direct access
defined( '_JEXEC' ) or die('Restricted access');
JHtml::_('behavior.keepalive');
JHtml::_('stylesheet', JUri::root() . 'modules/mod_miniorangesociallogin/css/bootstrap.min.css');
JHtml::_('stylesheet', JUri::root() . 'modules/mod_miniorangesociallogin/css/bootstrap.min-preview.css');
JHtml::_('stylesheet', JUri::root() . 'modules/mod_miniorangesociallogin/css/bootstrap.min-preview.css');
JHtml::_('stylesheet', JUri::root() . 'modules/mod_miniorangesociallogin/css/bootstrap-social.css');
JHtml::_('stylesheet', JUri::root() . 'media/com_miniorangesociallogin/css/mo_openid_style.css');
JHtml::_('stylesheet', JUri::root() . 'modules/mod_miniorangesociallogin/css/font-awesome.css');
JHtml::_('stylesheet', JUri::root() . 'modules/mod_miniorangesociallogin/css/font-awesome.min.css');

?>

<?php 
// Check for plugin enabled.
  jimport('joomla.plugin.helper');
      if (!defined('_JDEFINES')) {
        require_once JPATH_BASE . '/includes/defines.php';
    }
  require_once JPATH_BASE . '/includes/framework.php';
  ?>
<?php

if ($type == 'login') {  ?>
<?php 
    $session = JFactory::getSession();
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('*');
    $query->from($db->quoteName('#__miniorangesociallogin_apps_save'));
    $query->where($db->quoteName('id')." = 1");
    $db->setQuery($query);
    $default_config = $db->loadAssoc();

    
    $customSize=$default_config['icon_size'];
    $customWidth = $default_config['icon_width'];
    $customHeight = $default_config['icon_height'];
    $customBoundary = $default_config['icon_curve']; 
    $customBackground = $default_config['background_color']; 

    // pull all apps data
    // pull all active apps
    $appsConfigured = false;
        $db = JFactory::getDbo();

        $query = $db->getQuery( true );
        $query
            ->select('a.*')
            ->from($db->quoteName('#__miniorangesociallogin_apps_data','a'));
            
        $db->setQuery($query);
        $result = $db->loadObjectList();
         $activeApps = array('facebook'=>'0','instagram'=>'0','twitter'=>'0','linkedin'=>'0','google'=>'0','yahoo'=>'0');
        foreach ($result as $key => $value) {
            # code...
            $activeApps[$result[$key]->appName] = $result[$key]->active;
            if($result[$key]->active=='1'){
              $appsConfigured = true;
            }

        }





    ?>
   <form style="line-height: 3px" id="module" action="<?php echo JRoute::_('index.php', true, $params->get('usesecure')); ?>" method="post" id="mo_login-form">
    <?php if($appsConfigured){
        mo_openid_load_login_script() ;

        
        if($default_config['default_enable']=='default') {


            if ($default_config['round_enable'] == 'round') {
                if ($activeApps['facebook']=='1') { ?>
                    
                    <a onClick="moOpenIdLogin('facebook');" onLoad="mo_openid_login_validate;"> <img alt='Facebook'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:999px !important;"
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/facebook.png"
                                                                                                     class="<?php echo $default_config['round_enable']; ?> login-button">
                    </a>

                <?php }
                if ($activeApps['yahoo']=='1') {?>
                    
                    <a onClick="moOpenIdLogin('yahoo');" onLoad="mo_openid_login_validate;"> <img alt='Facebook'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:999px !important;"
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/yahoo.png"
                                                                                                     class="<?php echo $default_config['round_enable']; ?> login-button">
                    </a>

                <?php }
                if ($activeApps['google']=='1') {
                    ?>
                    <a onClick="moOpenIdLogin('google');" onLoad="mo_openid_login_validate;"> <img alt='Google'
                                                                                                   style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize ?>px !important; border-radius:999px !important;"
                                                                                                   src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/google.png"
                                                                                                   class="<?php echo $default_config['round_enable']; ?> login-button">
                    </a>

                <?php }
                if ($activeApps['twitter']=='1') {
                    ?>

                    <a onClick="moOpenIdLogin('twitter');" onLoad="mo_openid_login_validate;"> <img alt='Twitter'
                                                                                                    style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:999px !important;"
                                                                                                    src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/twitter.png"
                                                                                                    class="login-button">
                    </a>

                <?php }
                if ($activeApps['linkedin']=='1') {
                    ?>

                    <a onClick="moOpenIdLogin('linkedin');" onLoad="mo_openid_login_validate;"> <img alt='Linkedin'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:999px !important;"
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/linkedin.png"
                                                                                                     class="login-button">
                    </a>

                <?php }
                if ($activeApps['instagram']=='1') {
                    ?>
                    <a onClick="moOpenIdLogin('instagram');" onLoad="mo_openid_login_validate;"> <img alt='Instagram'
                                                                                                      style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize ?>px !important; border-radius:999px !important;"
                                                                                                      src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/insta.png"
                                                                                                      class="login-button">
                    </a>
          <?php } ?>
          
          <?php 
                    
            }

            if ($default_config['roundedge_enable'] == 'RoundedEdge') {
                if ($activeApps['facebook']=='1') { ?>
                    <br>
                    
                    <a onClick="moOpenIdLogin('facebook');" onLoad="mo_openid_login_validate;"> <img alt='Facebook'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize ?>px !important; border-radius:4px !important; "
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/facebook.png"
                                                                                                     class="login-button">
                    </a>

                <?php }
                if ($activeApps['yahoo']=='1') { ?>
                    <br>
                    
                    <a onClick="moOpenIdLogin('yahoo');" onLoad="mo_openid_login_validate;"> <img alt='Facebook'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize ?>px !important; border-radius:4px !important; "
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/yahoo.png"
                                                                                                     class="login-button">
                    </a>

                <?php }
                if ($activeApps['google']=='1') {
                    ?>

                    <a onClick="moOpenIdLogin('google');" onLoad="mo_openid_login_validate;"> <img alt='Google'
                                                                                                   style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:4px !important; "
                                                                                                   src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/google.png"
                                                                                                   class="login-button">
                    </a>

                <?php }
                if ($activeApps['twitter']=='1') {
                    ?>

                    <a onClick="moOpenIdLogin('twitter');" onLoad="mo_openid_login_validate;"> <img alt='Twitter'
                                                                                                    style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:4px !important; "
                                                                                                    src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/twitter.png"
                                                                                                    class="login-button">
                    </a>

                <?php }
                if ($activeApps['linkedin']=='1') {
                    ?>
                    <a onClick="moOpenIdLogin('linkedin');" onLoad="mo_openid_login_validate;"> <img alt='Linkedin'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:4px !important; "
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/linkedin.png"
                                                                                                     class="login-button">
                    </a>

                <?php }
                if ($activeApps['instagram']=='1') {
                    ?>
                    <a onClick="moOpenIdLogin('instagram');" onLoad="mo_openid_login_validate;"> <img alt='Instagram'
                                                                                                      style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; border-radius:4px !important; "
                                                                                                      src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/insta.png"
                                                                                                      class="login-button">
                    </a>

                    
                <?php }
            } else if ($default_config['square_enable'] == 'square') {


                if ($activeApps['facebook']=='1') { ?>
                    <br>

                    
                    <a onClick="moOpenIdLogin('facebook');" onLoad="mo_openid_login_validate;"> <img alt='Facebook'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; "
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/facebook.png"
                                                                                                     class="<?php echo $default_config['square_enable']; ?> login-button">
                    </a>

                <?php }
                if ($activeApps['yahoo']=='1') { ?>
                    <br>

                    
                    <a onClick="moOpenIdLogin('yahoo');" onLoad="mo_openid_login_validate;"> <img alt='Facebook'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; "
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/yahoo.png"
                                                                                                     class="<?php echo $default_config['square_enable']; ?> login-button">
                    </a>

                <?php }

                if ($activeApps['google']=='1') {
                    ?>
                    <a onClick="moOpenIdLogin('google');" onLoad="mo_openid_login_validate;"> <img alt='Google'
                                                                                                   style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize ?>px !important; "
                                                                                                   src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/google.png"
                                                                                                   class="<?php echo $default_config['square_enable']; ?> login-button">
                    </a>
                    <?php
                }

                if ($activeApps['twitter']=='1') {

                    ?>

                    <a onClick="moOpenIdLogin('twitter');" onLoad="mo_openid_login_validate;"> <img alt='Twitter'
                                                                                                    style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize ?>px !important; "
                                                                                                    src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/twitter.png"
                                                                                                    class="<?php echo $default_config['square_enable']; ?> login-button">
                    </a>


                <?php }
                if ($activeApps['linkedin']=='1') {
                    ?>

                    <a onClick="moOpenIdLogin('linkedin');" onLoad="mo_openid_login_validate;"> <img alt='Linkedin'
                                                                                                     style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; "
                                                                                                     src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/linkedin.png"
                                                                                                     class="<?php echo $default_config['square_enable']; ?> login-button">
                    </a>
                    
                <?php }
                if ($activeApps['instagram']=='1') {
                    ?>

                    <a onClick="moOpenIdLogin('instagram');" onLoad="mo_openid_login_validate;"> <img alt='Instagram'
                                                                                                      style="width:<?php echo $customSize ?>px !important; height:<?php echo $customSize; ?>px !important; "
                                                                                                      src="<?php echo JURI::root(); ?>media/com_miniorangesociallogin/images/insta.png"
                                                                                                      class="<?php echo $default_config['square_enable']; ?> login-button">
                    </a>
                    
                <?php }
            } elseif ($default_config['longbutton_enable'] == 'longbutton') {
                if ($activeApps['facebook']=='1') { ?>

                    <br>
                    
                        <div>
                            <a onClick="moOpenIdLogin('facebook');"
                               class="btn btn-block btn-social btn-facebook  btn-custom-size login-button"
                               style="width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary ?>px !important; padding-top:<?php echo $customHeight - 29 ?>px !important; padding-bottom:<?php echo $customHeight - 29 ?>px !important; ">
                                <i style="padding-top:<?php echo $customHeight - 35 ?>px !important;"
                                   class="fa fa-facebook"></i> Login with Facebook</a>
                        </div>
                    
                <?php }
                if ($activeApps['yahoo']=='1') { ?>

                    <br>
                    
                        <div>
                            <a onClick="moOpenIdLogin('yahoo');"
                               class="btn btn-block btn-social btn-yahoo  btn-custom-size login-button"
                               style="width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary ?>px !important; padding-top:<?php echo $customHeight - 29 ?>px !important; padding-bottom:<?php echo $customHeight - 29 ?>px !important; ">
                                <i style="padding-top:<?php echo $customHeight - 35 ?>px !important;"
                                   class="fa fa-yahoo"></i> Login with yahoo</a>
                        </div>
                    
                <?php }
                if ($activeApps['google']=='1') {
                    ?>
                    <br>
                    
                        <div>
                            <a onClick="moOpenIdLogin('google');"
                               class="btn btn-block btn-social btn-google  btn-custom-size login-button"
                               style="width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary ?>px !important; padding-top:<?php echo $customHeight - 29 ?>px !important; padding-bottom:<?php echo $customHeight - 29 ?>px !important; ">
                                <i style="padding-top:<?php echo $customHeight - 35 ?>px !important;"
                                   class="fa fa-google-plus"></i> Login with Google+</a>
                        </div>
                    

                <?php }
                if ($activeApps['twitter']=='1') {
                    ?>
                    <br>
                    
                        <div>
                            <a onClick="moOpenIdLogin('twitter');"
                               class="btn btn-block btn-social btn-twitter  btn-custom-size login-button"
                               style="width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary ?>px !important; padding-top:<?php echo $customHeight - 29 ?>px !important; padding-bottom:<?php echo $customHeight - 29 ?>px !important; ">
                                <i style="padding-top:<?php echo $customHeight - 35 ?>px !important;"
                                   class="fa fa-twitter"></i> Login with Twitter</a>
                        </div>
                    

                <?php }
                if ($activeApps['linkedin']=='1') {
                    ?>
                    <br>
                    
                        <div>
                            <a onClick="moOpenIdLogin('linkedin');"
                               class="btn btn-block btn-social btn-linkedin  btn-custom-size login-button"
                               style="width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary ?>px !important; padding-top:<?php echo $customHeight - 29 ?>px !important; padding-bottom:<?php echo $customHeight - 29 ?>px !important; ">
                                <i style="padding-top:<?php echo $customHeight - 35 ?>px !important;"
                                   class="fa fa-linkedin"></i> Login with Linkedin</a>
                        </div>
                    
                <?php }
                if ($activeApps['instagram'] == '1') {
                    ?>
                    <br>
                    
                        <div>
                            <a onClick="moOpenIdLogin('instagram');"
                               class="btn btn-block btn-social btn-instagram  btn-custom-size login-button"
                               style="width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary ?>px !important; padding-top:<?php echo $customHeight - 29 ?>px !important; padding-bottom:<?php echo $customHeight - 29 ?>px !important; ">
                                <i style="padding-top:<?php echo $customHeight - 35 ?>px !important;"
                                   class="fa fa-instagram"></i> Login with Instagram</a>
                        </div>
                    
                <?php }
            }
        }
        
        
        
        
        else if($default_config['custom_enable']=='custom')
        
        {
        
                if($default_config['round_enable']=='round')
                    {
    ?>
 
        
    <?php
if ($activeApps['facebook'] == '1')    {?>
     <br>
     <div>
       
     <a onClick="moOpenIdLogin('facebook');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;   border-radius:999px !important; background:<?php echo '#'.$customBackground; ?> !important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-facebook custom-login-button "></i></a> 
     
    <?php } 
    if ($activeApps['yahoo'] == '1')    {?>
     <br>
     <div>
       
     <a onClick="moOpenIdLogin('yahoo');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;   border-radius:999px !important; background:<?php echo '#'.$customBackground; ?> !important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-facebook custom-login-button "></i></a> 
     
    <?php } 
    if ($activeApps['google'] == '1') {
     ?>
     

     <a onClick="moOpenIdLogin('google');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px; height:<?php echo $customSize;?>px !important; border-radius:999px !important; background:<?php echo '#'.$customBackground; ?> !important; font-size:<?php echo $customSize-16?>px !important" class="fa fa-google-plus custom-login-button <?php echo $default_config['round_enable'];?>"></i></a><?php //echo $customSize-16; exit;?>
     
         
    <?php } if ($activeApps['twitter'] == '1') {
      ?>
    
     <a onClick="moOpenIdLogin('twitter');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px; height:<?php echo $customSize;?>px; border-radius:999px; background:<?php echo '#'.$customBackground?>; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-twitter custom-login-button <?php echo $default_config['round_enable'];?>"></i></a> 
      
    <?php } 
    if ($activeApps['linkedin'] == '1') {
    ?>
     
  <a onClick="moOpenIdLogin('linkedin');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px; height:<?php echo $customSize;?>px; border-radius:999px; background:<?php echo '#'.$customBackground?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-linkedin custom-login-button <?php echo $default_config['round_enable'];?>"></i></a> 
     
    </div>

    <?php }
    if ($activeApps['instagram'] == '1') {
                            ?>
        <a onClick="moOpenIdLogin('instagram');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px; height:<?php echo $customSize;?>px; border-radius:999px; background:<?php echo '#'.$customBackground?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-instagram custom-login-button <?php echo $default_config['round_enable'];?>"></i></a>
        </div>

                        <?php }
    }
                else if($default_config['roundedge_enable']=='RoundedEdge'){
if ($activeApps['facebook'] == '1')    {     ?>
 <br>
 <div>
      
        <a onClick="moOpenIdLogin('facebook');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground ?>!important; font-size:<?php echo $customSize-16 ?>px !important;" class="fa fa-facebook custom-login-button oval<?php //echo $default_config['roundedge_enable'];?>"></i></a>
           
<?php } 
    if ($activeApps['google'] == '1') {
?>

        <a onClick="moOpenIdLogin('google');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground; ?>!important; font-size:<?php echo $customSize-16?>px !important" class="fa fa-google-plus custom-login-button oval "></i></a>
       
<?php } 
    if ($activeApps['twitter'] == '1') {
?>
    
        <a onClick="moOpenIdLogin('twitter');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important; background:<?php echo '#'.$customBackground ?>!important; font-size:<?php echo $customSize-16 ?>px !important;" class="fa fa-twitter custom-login-button oval"></i></a>
       
<?php } 
    if ($activeApps['linkedin'] == '1') {
?>
     
        <a onClick="moOpenIdLogin('linkedin');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground; ?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-linkedin custom-login-button oval"></i></a>
       
      </div>      
    <?php }
    if ($activeApps['instagram'] == '1') {
        ?>

        <a onClick="moOpenIdLogin('instagram');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground; ?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-instagram custom-login-button oval"></i></a>

        </div>
        <?php
                    }
            } 
    else if($default_config['square_enable']=='square') {
if ($activeApps['facebook'] == '1')    {        //} else { ?>

       <div>
        <a onClick="moOpenIdLogin('facebook');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground?> !important; font-size:<?php echo $customSize-16?>px !important; " class="fa fa-facebook custom-login-button <?php echo $default_config['square_enable']?>"></i></a>
      
<?php } 
    if ($activeApps['google'] == '1') {
?>

        <a onClick="moOpenIdLogin('google');" onLoad="mo_openid_login_validate;"><i style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-google-plus custom-login-button <?php echo $default_config['square_enable']?>"></i></a>
       

<?php } 
    if ($activeApps['twitter'] == '1') {
?>
    
        <a onClick="moOpenIdLogin('twitter');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-twitter custom-login-button <?php echo $default_config['square_enable']?>"></i></a>
       

<?php } 
    if ($activeApps['linkedin'] == '1') {
?>
     
        <a onClick="moOpenIdLogin('linkedin');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-linkedin custom-login-button <?php echo $default_config['square_enable']?>"></i></a>
       
      </div>      
<?php     }
    if ($activeApps['instagram'] == '1') {
        ?>

        <a onClick="moOpenIdLogin('instagram');" onLoad="mo_openid_login_validate;"><i  style="width:<?php echo $customSize?>px !important; height:<?php echo $customSize?>px !important;  background:<?php echo '#'.$customBackground?>!important; font-size:<?php echo $customSize-16?>px !important;" class="fa fa-instagram custom-login-button <?php echo $default_config['square_enable']?>"></i></a>

        </div>
        <?php     }
     } 
     elseif ($default_config['longbutton_enable'] == 'longbutton')  {
        if ($activeApps['facebook'] == '1')    { ?>    

        <br>
        <div>
       <div>
    <a onClick="moOpenIdLogin('facebook');" class="btn btn-block btn-social btn-facebook  btn-custom-size login-button" style="background:<?php echo '#'.$customBackground; ?>!important; width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary; ?>px !important; padding-top:<?php echo $customHeight-29?>px !important; padding-bottom:<?php echo $customHeight-29?>px !important;"> <i style="padding-top:<?php echo $customHeight-35?>px !important;" class="fa fa-facebook"></i>Login with Facebook</a>
       </div>
      </div>
<?php } 
if ($activeApps['yahoo'] == '1')    { ?>    

        <br>
        <div>
       <div>
    <a onClick="moOpenIdLogin('facebook');" class="btn btn-block btn-social btn-facebook  btn-custom-size login-button" style="background:<?php echo '#'.$customBackground; ?>!important; width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary; ?>px !important; padding-top:<?php echo $customHeight-29?>px !important; padding-bottom:<?php echo $customHeight-29?>px !important;"> <i style="padding-top:<?php echo $customHeight-35?>px !important;" class="fa fa-facebook"></i>Login with Facebook</a>
       </div>
      </div>
<?php } 
    if ($activeApps['google'] == '1') {
?>      
      <br>
      <div>
       <div>
        <a onClick="moOpenIdLogin('google');" class="btn btn-block btn-social btn-google  btn-custom-size login-button" style="background:<?php echo '#'.$customBackground; ?>!important; width: <?php echo $customWidth ?>px !important;border-radius:<?php echo $customBoundary; ?>px !important; padding-top:<?php echo $customHeight-29?>px !important; padding-bottom:<?php echo $customHeight-29?>px !important; "> <i style="padding-top:<?php echo $customHeight-35?>px !important;" class="fa fa-google"></i>Login with Google+</a>
       </div>
      </div>
      
    <?php } 
    if ($activeApps['twitter'] == '1') {
?>  
      <br>
      <div>
       <div>
        <a onClick="moOpenIdLogin('twitter');" class="btn btn-block btn-social btn-twitter  btn-custom-size login-button" style="background:<?php echo '#'.$customBackground; ?>!important; width: <?php echo $customWidth ?>px !important; border-radius:<?php echo $customBoundary; ?>px !important; padding-top:<?php echo $customHeight-29?>px !important; padding-bottom:<?php echo $customHeight-29?>px !important;"> <i style="padding-top:<?php echo $customHeight-35?>px !important;" class="fa fa-twitter"></i>Login with Twitter</a>
       </div>
      </div>
      
    <?php } 
    if ($activeApps['linkedin'] == '1') {
?>  
      <br>
      <div>
       <div>
    <a onClick="moOpenIdLogin('linkedin');" class="btn btn-block btn-social btn-linkedin  btn-custom-size login-button" style="background:<?php echo '#'.$customBackground; ?>!important; width: <?php echo $customWidth ?>px !important;border-radius:<?php echo $customBoundary; ?>px !important; padding-top:<?php echo $customHeight-29?>px !important; padding-bottom:<?php echo $customHeight-29?>px !important;"> <i style="padding-top:<?php echo $customHeight-35?>px !important;" class="fa fa-linkedin"></i>Login with Linkedin</a>
       </div>
      </div>
      <?php }
    if ($activeApps['instagram'] == '1') {
        ?>
        <br>
        <div>
            <div>
                <a onClick="moOpenIdLogin('instagram');" class="btn btn-block btn-social btn-instagram  btn-custom-size login-button" style="background:<?php echo '#'.$customBackground; ?>!important; width: <?php echo $customWidth ?>px !important;border-radius:<?php echo $customBoundary; ?>px !important; padding-top:<?php echo $customHeight-29?>px !important; padding-bottom:<?php echo $customHeight-29?>px !important;"> <i style="padding-top:<?php echo $customHeight-35?>px !important;" class="fa fa-instagram"></i>Login with Instagram</a>
            </div>
        </div>
        <?php }
            }

        }?></form><?php
    } else{?>
     <form action="<?php echo JRoute::_('index.php', true, $params->get('usesecure')); ?>" method="post" id="mo_login-form"></form>
<?php }} ?>
<?php 
$sociallogin = mo_openid_login_validate();

?>

        <?php
            
        function mo_openid_load_login_script() { 
?>
<script type="text/javascript">
                function moOpenIdLogin(app_name) {
                
                <?php
                    
                    if(isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off'){
                        $http = "https://";
                    } else {
                        $http =  "http://";
                    }
                    if ( strpos($_SERVER['REQUEST_URI'],'index.php') !== FALSE){
                        $redirect_url = JURI::base() . '?option1=com_content&mo_social_app_name_login=';
    
                    }else{
                        $redirect_url = $http . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
                        if(strpos($redirect_url, '?') !== false) {
                            $redirect_url .= '&option1=com_content&mo_social_app_name_login=';
                        } else {
                            $redirect_url .= '?option1=com_content&mo_social_app_name_login=';
                            
                        }
                    }

                ?>

                window.location.href = '<?php echo $redirect_url; ?>' + app_name;
            
            }
        
        </script>
<?php
} ?>
<?php
require_once JPATH_BASE . '/includes/framework.php';
?>